import numpy as np
import matplotlib.pyplot as plt
import sympy as sym
import math
import os
import subprocess
import fileinput
import re
# import matlab.engine
from HelperFunctions import *
from ClassifyMin import *

import matplotlib.ticker as tickers
import matplotlib as mpl
from matplotlib.ticker import MultipleLocator,FormatStrFormatter,MaxNLocator
import pandas as pd
# from subprocess import Popen, PIPE
#import sys

###################### plot-q3-gamma .py #########################
# ..TODO Documentation ...
#  Generalized Plot-Script giving the option to define
#  quantity of interest and the parameter it depends on
#  to create a plot
#
#  Input: Define y & x for "x-y plot" as Strings
#  - Run the 'Cell-Problem' for the different Parameter-Points
#  (alternatively run 'Compute_MuGamma' if quantity of interest
#   is q3=muGamma for a significant Speedup)

###########################################################


# ----- Setup Paths -----

InputFile  = "/inputs/computeMuGamma.parset"
OutputFile = "/outputs/outputMuGamma.txt"
# path = os.getcwd()
# InputFilePath = os.getcwd()+InputFile
# OutputFilePath = os.getcwd()+OutputFile
# --------- Run  from src folder:
path_parent = os.path.dirname(os.getcwd())
os.chdir(path_parent)
path = os.getcwd()
print(path)
InputFilePath = os.getcwd()+InputFile
OutputFilePath = os.getcwd()+OutputFile
print("InputFilepath: ", InputFilePath)
print("OutputFilepath: ", OutputFilePath)
print("Path: ", path)

#---------------------------------------------------------------

print('---- Input parameters: -----')
mu1 = 1.0
rho1 = 1.0
# alpha = 2.8
alpha = 2.0
beta = 2.0
# beta = 10.0
theta = 1.0/4.0
# theta = 1.0/8.0
# lambda1 = 0.0
# gamma = 1.0/4.0
# gamma = 'infinity'


#TEST
# theta = 0.1


print('mu1: ', mu1)
print('rho1: ', rho1)
print('alpha: ', alpha)
print('beta: ', beta)
print('theta: ', theta)
# print('gamma:', gamma)
print('----------------------------')

yName = 'q3'
xName = 'gamma'
# --- Define Interval of x-values:
xmin = 0.01
# xmin = 1.0
xmax = 3.0
numPoints = 100
X_Values = np.linspace(xmin, xmax, num=numPoints)
print(X_Values)
Y_Values = []

q1 = (1.0/6.0)*harmonicMean(mu1, beta, theta)
q2 = (1.0/6.0)*arithmeticMean(mu1, beta, theta)

print('q1=', q1)
print('q2=',q2)

for x in X_Values:
    # fist replace old parameters in parset
    # SetParametersCellProblem(alpha,beta,theta,gamma,mu1,rho1,lambda1,InputFilePath)


    # SetParametersComputeMuGamma(beta,theta,gamma,mu1,rho1, InputFilePath)
    SetParametersComputeMuGamma(beta,theta,x,mu1,rho1, InputFilePath)

    # replace the sought after x value in the parset
    with open(path+"/inputs/computeMuGamma.parset", 'r') as file:
        filedata = file.read()
    filedata = re.sub('(?m)^'+xName+'=.*',xName+'='+str(x),filedata)
    f = open(path+"/inputs/computeMuGamma.parset",'w')
    f.write(filedata)
    f.close()
    #Run Compute_MuGamma since its much faster
    print("Run Compute_MuGamma for " + xName + " =" , x)
    subprocess.run(['./build-cmake/src/Compute_MuGamma', './inputs/computeMuGamma.parset'],
                                                         capture_output=True, text=True)
    #Extract mu_gamma from Output-File
    with open(path + '/outputs/outputMuGamma.txt', 'r') as file:
        output = file.read()
    tmp = re.search(r'(?m)^mu_gamma=.*',output).group()                           # Not necessary for Intention of Program t output Minimizer etc.....
    s = re.findall(r"[-+]?\d*\.\d+|\d+", tmp)
    Y_Values.append(float(s[0]))

    print('Error(q3-q1):', float(s[0])-q1)

# ------------end of for-loop -----------------
print("(Output) Values of " + yName + ": ", Y_Values)
# ----------------end of if-statement -------------






# --- Convert to numpy array
Y_Values = np.array(Y_Values)
X_Values = np.array(X_Values)

# ---------------- Create Plot -------------------
# plt.style.use("seaborn-darkgrid")
# plt.style.use("seaborn-whitegrid")
plt.style.use("seaborn")
# plt.style.use("seaborn-paper")
# plt.style.use('ggplot')
# plt.rcParams["font.family"] = "Avenir"
# plt.rcParams["font.size"] = 16

# plt.style.use("seaborn-darkgrid")
mpl.rcParams['text.usetex'] = True
mpl.rcParams["font.family"] = "serif"
mpl.rcParams["font.size"] = "10"
# mpl.rcParams['xtick.labelsize'] = 16mpl.rcParams['xtick.major.size'] = 2.5
# mpl.rcParams['xtick.bottom'] = True
# mpl.rcParams['ticks'] = True
mpl.rcParams['xtick.bottom'] = True
mpl.rcParams['xtick.major.size'] = 3
mpl.rcParams['xtick.minor.size'] = 1.5
mpl.rcParams['xtick.major.width'] = 0.75
mpl.rcParams['ytick.left'] = True
mpl.rcParams['ytick.major.size'] = 3
mpl.rcParams['ytick.minor.size'] = 1.5
mpl.rcParams['ytick.major.width'] = 0.75

mpl.rcParams.update({'font.size': 10})
mpl.rcParams['axes.labelpad'] = 0.0

## OLD STYLE :
# mpl.rcParams['text.usetex'] = True
# mpl.rcParams["font.family"] = "serif"
# mpl.rcParams["font.size"] = "9"
# width as measured in inkscape
width = 6.28 *0.5
height = width / 1.618
fig = plt.figure()
# ax = plt.axes((0.15,0.18,0.8,0.8))
# ax = plt.axes((0.15,0.21 ,0.8,0.75))
ax = plt.axes((0.195,0.21 ,0.8,0.75))
ax.tick_params(axis='x',which='major', direction='out',pad=3)
ax.tick_params(axis='y',which='major', length=3, width=1, direction='out',pad=3)
ax.xaxis.set_major_locator(MultipleLocator(0.5))
ax.xaxis.set_minor_locator(MultipleLocator(0.25))

# ax.plot(X_Values, Y_Values)



# ADD SCATTER :
# ax.plot(X_Values, Y_Values,   # data
# marker='o',     # each marker will be rendered as a circle
# markersize=4,   # marker size
# markerfacecolor='orange',   # marker facecolor
# markeredgecolor='black',  # marker edgecolor
# markeredgewidth=1,       # marker edge width
# # linestyle='--',            # line style will be dash line
# linewidth=1,
# zorder=3)          # line width

ax.plot(X_Values, Y_Values, linewidth=1, zorder=3)          # line width


ax.set_xlabel(r"$\gamma$")
ax.set_ylabel(r"$q_3(\gamma)$", labelpad=4)






# plt.figure()
# # plt.title(r''+ yName + '-Plot')
# plt.plot(X_Values, Y_Values)
# plt.scatter(X_Values, Y_Values)
# # plt.axis([0, 6, 0, 20])
# plt.xlabel(xName)
# plt.ylabel(yName)


# plt.axhline(y = 1.90476, color = 'forestgreen', linestyle = ':', label='$q_1$')
# plt.axhline(y = 2.08333, color = 'darkorange', linestyle = 'dashed', label='$q_2$')
l1 = plt.axhline(y = q1, color = 'forestgreen', linestyle = 'dashed', label='$q_1$')
l2 = plt.axhline(y = q2, color = 'darkorange', linestyle = 'dashed', label='$q_2$')
# plt.axhline(y = q1, color = 'forestgreen', linestyle = 'dashed', label=r'$\langle \mu \rangle $')
# plt.axhline(y = q2, color = 'darkorange', linestyle = 'dashed', label='$\overline{\mu}$')
# legend = ax.legend(loc = 'center right')

legend = fig.legend([l1, l2], [r"$q_1$", r"$q_2$"],
            # bbox_to_anchor=[0.5, 0.92],
            bbox_to_anchor=[0.89, 0.6],
            loc='center',
            ncol=1,
            frameon=True)

frame = legend.get_frame()
# frame.set_color('white')
frame.set_edgecolor('gray')

# plt.legend()

fig.set_size_inches(width, height)
fig.savefig('Plot-q3-Gamma.pdf')



plt.show()
# #---------------------------------------------------------------
