
import math
#from python_matrix_operations import *
import ctypes
import os
import sys
import numpy as np
import elasticity_toolbox as elast

class ParameterSet(dict):
    def __init__(self, *args, **kwargs):
        super(ParameterSet, self).__init__(*args, **kwargs)
        self.__dict__ = self

parameterSet = ParameterSet()
#---------------------------------------------------------------
# Polymeric matrix material without prestrin
# design parameter: fibre diameterthickness in mmm of fibre d
param_r = 0.125
param_t = 0.6
param_h = 0.3
param_vol = 0.16
param_gamma = 0.5867087822139629
# eingestrain in percent
param_eigenstrain = 0.2
# height mm
# volume fraction
vol = param_vol
# period 
# epsilon_ = np.pi*param_r**2/(h*vol)
# Wir nutzen w\"ufel:
epsilon_ = (np.pi*param_r**2)/(param_h*param_vol*2)
# width of fibres in after rescaling to unit cell
fibre_height=np.sqrt(param_vol/param_gamma)
fibre_width=np.sqrt(param_vol*param_gamma) # ~0.07
# Ellipsoidal
r_height=param_r/param_t
r_width=r_height*param_gamma

# --- define geometry
def indicatorFunction(x):
    centerpoint_vert=-0.5+0.5*param_h/param_t
#    if (np.abs(x[2]+.25)<=fibre_height/2) and (x[1]+0.5<=fibre_width): # square geometry
    if ((x[2]-centerpoint_vert)**2+(x[1]/param_gamma)**2<=(param_r/param_t)**2): # round geometry
        return 1  # fibre
    else :
        return 2   # matrix

# --- Number of material phases
parameterSet.Phases=2

# --- PHASE 1 fibre
parameterSet.phase1_type="isotropic"
# E in MPa and nu
E = 7
nu = .47
# [mu, lambda]
materialParameters_phase1 = [E/(2*(1+nu)), (E*nu)/((1+nu)*(1-2*nu))]
def prestrain_phase1(x):
    fitting_factor=0.95
    factor = fitting_factor*(param_eigenstrain - 0.0009)/param_t
    factor_quer= -factor/2 # to keep volume konstant
    return [[factor,0,0],[0,factor_quer,0],[0,0,factor_quer]]

# --- PHASE 2
# --- PHASE 1 fibre
parameterSet.phase2_type="isotropic"
# E in MPa and nu
E = 0.7
nu = 0.47
# [mu, lambda]
materialParameters_phase2 = [E/(2*(1+nu)), (E*nu)/((1+nu)*(1-2*nu))]
def prestrain_phase2(x):
    return [[0,0,0],[0,0,0],[0,0,0]]

