import math
import numpy as np

class ParameterSet(dict):
    def __init__(self, *args, **kwargs):
        super(ParameterSet, self).__init__(*args, **kwargs)
        self.__dict__ = self

parameterSet = ParameterSet()

""""
    Experiment: Plates with prestrained fibres with quadratic cross section r**2 
                and vertical position

    r: fibreRadius

"""

#############################################
#  Paths
#############################################
parameterSet.resultPath = '/home/klaus/Desktop/Dune_bendIso/dune-microstructure/outputs_prestrainedFibre_anisotropicB'
parameterSet.baseName= 'prestrainedFibre_anisotropicB'

##################### MICROSCALE PROBLEM ####################
class Microstructure:
    def __init__(self):
        self.gamma = 1.0    #in the future this might change depending on macroPoint.
        self.phases = 2     #in the future this might change depending on macroPoint.
        #--- Define different material phases:
        #- PHASE 1
        # self.phase1_type="isotropic"
        # mu_phase1 = 100

        # self.materialParameters_phase1 = [mu_phase1, 1.0]   

        self.phase1_type="general_anisotropic"
        # self.materialParameters_phase1 =np.array([[1/50,  1,  0,   0.0,    0.0,    0.0],
        #                                          [1,   1/50,  1/300,   0.0,    0.0,    0.0],
        #                                          [0,           1/300,  1/5,   0.0,    0.0,    0.0],
        #                                          [0.0,       0.0,  0.0,     1/25,   0.0,    0.0],
        #                                          [0.0,       0.0,  0.0,     0.0,   1/50,    0.0],
        #                                          [0.0,       0.0,  0.0,     0.0,    0.0,   1/10]]);


        #INVERSE:
        # self.materialParameters_phase1 =np.array([[-1.10e-4,  3.37e-3,  -3.21e-3,   0.0,    0.0,    0.0],
        #                                           [3.37e-3,   -1.18e-3,  1.12e-3,   0.0,    0.0,    0.0],
        #                                           [-3.21e-3,  1.12e-3,   8.45e-3,   0.0,    0.0,    0.0],
        #                                           [0.0,       0.0,  0.0,     1e-2,   0.0,    0.0],
        #                                           [0.0,       0.0,  0.0,     0.0,   2e-2,    0.0],
        #                                           [0.0,       0.0,  0.0,     0.0,    0.0,   1.33e-2]]);
    




        # self.materialParameters_phase1 =np.array([[1,  8,  -0.5,   0.0,    0.0,    0.0],
        #                                         [8,   10000,  -180,   0.0,    0.0,    0.0],
        #                                         [-0.5,   -180,  2,   0.0,    0.0,    0.0],
        #                                         [0.0,       0.0,  0.0,     1,   0.0,    0.0],
        #                                         [0.0,       0.0,  0.0,     0.0,   10000,    0.0],
        #                                         [0.0,       0.0,  0.0,     0.0,    0.0,   5]]);
        

        self.materialParameters_phase1 =np.array([   [ 9.13e-01,  -5.45e-03,  -2.62e-01,   0.00e+00,   0.00e+00,   0.00e+00],
                                                [-5.45e-03,  -1.29e-04,  -1.30e-02,  -0.00e+00,  -0.00e+00,  -0.00e+00],
                                                [-2.62e-01,  -1.30e-02,  -7.31e-01,  -0.00e+00,  -0.00e+00,  -0.00e+00],
                                                [ 0.00e+00,   0.00e+00,   0.00e+00,   1.00e+00,   0.00e+00,   0.00e+00],
                                                [ 0.00e+00,   0.00e+00,   0.00e+00,   0.00e+00,   1.00e-04,   0.00e+00],
                                                [ 0.00e+00,   0.00e+00,   0.00e+00,   0.00e+00,   0.00e+00,   2.00e-01]])
    
        # self.materialParameters_phase1 =np.array([[ 2.80e-01,  -2.26e-02,  -9.18e-03,   0.00e+00,   0.00e+00,   0.00e+00],
        #                                         [-2.26e-02,   2.83e-03,   1.37e-03,  -0.00e+00,  -0.00e+00,  -0.00e+00],
        #                                         [-9.18e-03,   1.37e-03,   3.52e-02,   0.00e+00,   0.00e+00,   0.00e+00],
        #                                         [ 0.00e+00,   0.00e+00,   0.00e+00,   2.00e-02,   0.00e+00,   0.00e+00],
        #                                         [ 0.00e+00,   0.00e+00,   0.00e+00,   0.00e+00,   1.00e-03,   0.00e+00],
        #                                         [ 0.00e+00,   0.00e+00,   0.00e+00,   0.00e+00,   0.00e+00,   2.00e-02]])

        # self.materialParameters_phase1 =np.array([
        #                     [ 2.71e-02,   4.40e-03,   1.89e-03,  -0.00e+00,  -0.00e+00 , -0.00e+00],
        #                     [ 4.40e-03,   2.74e-03,   1.05e-03,   0.00e+00,   0.00e+00 ,  0.00e+00],
        #                     [ 1.89e-03,   1.05e-03,   2.08e-02,   0.00e+00,   0.00e+00 ,  0.00e+00],
        #                     [ 0.00e+00,   0.00e+00,   0.00e+00,   2.00e-02,   0.00e+00 ,  0.00e+00],
        #                     [ 0.00e+00,   0.00e+00,   0.00e+00,   0.00e+00,   2.00e-03 ,  0.00e+00],
        #                     [ 0.00e+00,   0.00e+00,   0.00e+00,   0.00e+00,   0.00e+00 ,  2.00e-02]])
        #INVERSE:
        # self.materialParameters_phase1 =np.array([  [-6.33e-05,  -1.25e-03,  -4.61e-04,  -0.00e+00,  -0.00e+00,  -0.00e+00],
        #     [-1.25e-03,  -7.83e-05,  -4.16e-05,  -0.00e+00,  -0.00e+00,  -0.00e+00],
        #     [-4.61e-04,  -4.16e-05,   2.04e-02,   0.00e+00,   0.00e+00,   0.00e+00],
        #     [ 0.00e+00,   0.00e+00,   0.00e+00,   2.00e-02,   0.00e+00,   0.00e+00],
        #     [ 0.00e+00,   0.00e+00,   0.00e+00,   0.00e+00,   2.04e-02,   0.00e+00],
        #     [ 0.00e+00,   0.00e+00,   0.00e+00,   0.00e+00,   0.00e+00,   2.00e-02]]);
        # self.materialParameters_phase1 =np.array([[ 8.28e-04,  -1.66e-03,  -1.84e-03,  -0.00e+00,  -0.00e+00,  -0.00e+00],
        #                                           [-1.66e-03,   1.66e-03,  -2.33e-03,  -0.00e+00,  -0.00e+00,  -0.00e+00],
        #                                           [-1.84e-03,  -2.33e-03,   2.42e-03,   0.00e+00,   0.00e+00,   0.00e+00],
        #                                           [ 0.00e+00,   0.00e+00,   0.00e+00,   2.00e-02,   0.00e+00,   0.00e+00],
        #                                           [ 0.00e+00,   0.00e+00,   0.00e+00,   0.00e+00,   2.00e-02,   0.00e+00],
        #                                           [ 0.00e+00,   0.00e+00,   0.00e+00,   0.00e+00,   0.00e+00,   2.00e-02]]);
        
        # self.materialParameters_phase1 =np.array([[ 8.27e-04,  -1.68e-03,  -1.82e-03,  -0.00e+00,  -0.00e+00,  -0.00e+00]
        #                                             [-1.68e-03,   1.66e-03,  -2.32e-03,  -0.00e+00,  -0.00e+00,  -0.00e+00]
        #                                             [-1.82e-03,  -2.32e-03,   2.42e-03,   0.00e+00,   0.00e+00,   0.00e+00]
        #                                             [ 0.00e+00,   0.00e+00,   0.00e+00,   1.25e-02,   0.00e+00,   0.00e+00]
        #                                             [ 0.00e+00,   0.00e+00,   0.00e+00,   0.00e+00,   2.50e-02,   0.00e+00]
        #                                             [ 0.00e+00,   0.00e+00,   0.00e+00,   0.00e+00,   0.00e+00,   2.22e-02]]);
        # self.materialParameters_phase1 =np.array([[ 1.20e-03,  -1.90e-03,  -2.50e-03,  -0.00e+00,  -0.00e+00,  -0.00e+00],
        #                                           [-1.90e-03,   8.01e-04,  -2.17e-03,  -0.00e+00,  -0.00e+00,  -0.00e+00],
        #                                           [-2.50e-03,  -2.17e-03,   3.59e-03,   0.00e+00,   0.00e+00,   0.00e+00],
        #                                           [ 0.00e+00,   0.00e+00,   0.00e+00,   1.25e-02,   0.00e+00,   0.00e+00],
        #                                           [ 0.00e+00,   0.00e+00,   0.00e+00,   0.00e+00,   1.43e-02,   0.00e+00],
        #                                           [ 0.00e+00,   0.00e+00,   0.00e+00,   0.00e+00,   0.00e+00,   1.33e-02]])
        
        

        
        # self.materialParameters_phase1 =np.array([[1/100,  1/300,  0,   0.0,   0.0,  0.0],
        #                                          [1/300,   1/600,  0,   0.0,   0.0,  0.0],
        #                                          [0,    0,  1/100,   0.0,   0.0,  0.0],
        #                                          [0.0,   0.0,  0.0,    1/50,   0.0,  0.0],
        #                                          [0.0,   0.0,  0.0,    0.0,   1/50,  0.0],
        #                                          [0.0,   0.0,  0.0,    0.0,  0.0,   1/50]]);
        # self.materialParameters_phase1 = [63.89, 0.2] #carbon fibre
        
        # #- PHASE 2
        self.phase2_type="isotropic"
        self.materialParameters_phase2 = [100.0, 1.0]    
        # self.materialParameters_phase2 = [1.48, 0.26]   #epoxy resin
        
    def indicatorFunction(self,x):
        verticalMidpointPosition = 0.25
        fibreRadius = 0.25
        if (np.max([abs(x[2]-verticalMidpointPosition), abs(x[0]-0.5)]) < fibreRadius):
            return 1    #Phase1   
        else :
            return 2    #Phase2
        # if (np.max([abs(x[2]-verticalMidpointPosition), abs(x[1]-0.5)]) < fibreRadius):
        #     return 1    #Phase1   
        # else :
        #     return 2    #Phase2
        
    #--- Define prestrain function for each phase (also works with non-constant values)
    def prestrain_phase1(self,x):
        rho =  1.0
        return [[rho*1.0, 0.0, 0], [0.0,rho*1.0,0], [0,0,rho*1.0]]

    def prestrain_phase2(self,x):
        return [[0, 0, 0], [0,0,0], [0,0,0]]



#############################################
#  Grid parameters
#############################################
parameterSet.microGridLevel = 4

#############################################
#  Assembly options
#############################################
parameterSet.set_IntegralZero = 1            #(default = false)
parameterSet.set_oneBasisFunction_Zero = 1   #(default = false)
#parameterSet.arbitraryLocalIndex = 7            #(default = 0)
#parameterSet.arbitraryElementNumber = 3         #(default = 0)

#############################################
#  Solver Options, Type: #1: CG - SOLVER , #2: GMRES - SOLVER, #3: QR - SOLVER, #4: UMFPACK - SOLVER (default)
#############################################
parameterSet.Solvertype = 4        # recommended to use iterative solver (e.g GMRES) for finer grid-levels
parameterSet.Solver_verbosity = 0  #(default = 2)  degree of information for solver output


#############################################
#  Write/Output options      #(default=false)
#############################################
# --- (Optional output) write Material / prestrain / Corrector functions to .vtk-Files:
parameterSet.write_materialFunctions = 1   # VTK indicator function for material/prestrain definition
#parameterSet.write_prestrainFunctions = 1  # VTK norm of B (currently not implemented)
parameterSet.MaterialSubsamplingRefinement= 2

# --- (Additional debug output)
parameterSet.print_debug = 0  #(default=false)

parameterSet.print_corrector_matrices = 0

# --- Write Correctos to VTK-File:  
parameterSet.writeCorrectorsVTK = 1

# --- Use caching of element matrices:  
parameterSet.cacheElementMatrices = 1

# --- check orthogonality (75) from paper: 
parameterSet.write_checkOrthogonality = 0

# --- write effective quantities (Qhom.Beff) to .txt-files
parameterSet.write_EffectiveQuantitiesToTxt = True



