# build with "chmod +x build_SingularityContainer.sh"
# run via "./build_SingularityContainer.sh"

# Define your local path for simulation results and figures
# echo "Define output path on your host machine: " 
# # LOCALPATH='/home/klaus/Desktop/test'
# read LOCALPATH

# macrosim_image="macrosim_image"
# CONTAINERNAME="macrosim_container"
# echo "macrosim_image: $macrosim_image"


docker rmi -f macrosim_image:latest 

# docker build --no-cache=true -t macrosim_image -f Containerfile .
docker build --no-cache=true -t macrosim_image -f Containerfile .
# docker build -t macrosim_image -f Containerfile .
# no-cahe=true sorgt dafür dass Container nochmal komplett neu gebaut wird!
    

# docker rm macrosim_container

image_id=$(docker images --quiet | head -1)

echo "image ID used: $image_id"

# Save docker image in .tar-file
# docker save $image_id -o macrosim_image.tar
docker save $image_id -o macrosim_image.tar

# Convert docker .tar-file to singularity container
# singularity build  macrosim_container.sif docker-archive://macrosim_image.tar
singularity build  macrosim_container.sif docker-archive://macrosim_image.tar

#Run Singularity Container via:
# ./macrosim_container.sif python3 /dune/dune-microstructure/microstructure_testsuite/macro-problem-testsuite.py 1 #EXPERIMENT_id


# (Optional) Move Container to Barnard.
echo "Move to Barnard(HPC) ? " 

read HPC_flag 

if [ "$HPC_flag" == "true" ] || [ $HPC_flag -eq 1 ] || [ "$HPC_flag" == "yes" ]
then
    echo "Moving to Barnard..." 
    rsync macrosim_container.sif s7603593@dataport1.hpc.tu-dresden.de:/data/horse/ws/s7603593-microstructure
    rsync macrosim.batch  s7603593@dataport1.hpc.tu-dresden.de:/data/horse/ws/s7603593-microstructure
fi