# build with "chmod +x build_SingularityContainer.sh"
# run via "./build_SingularityContainer.sh"

# Define your local path for simulation results and figures
echo "Define output path on your host machine: " 
# LOCALPATH='/home/klaus/Desktop/test'
read LOCALPATH

IMAGE_NAME = macrosim_image
CONTAINER_NAME = macrosim_container
echo "IMAGE_NAME: $IMAGE_NAME"

# docker build --no-cache=true -t macrosim_image -f Containerfile .
docker build --no-cache=true -t IMAGE_NAME -f Containerfile .

# docker rm macrosim_container

image_id=$(docker images --quiet | head -1)

echo "image ID used: $image_id"

# Save docker image in .tar-file
# docker save $image_id -o macrosim_image.tar
docker save $image_id -o IMAGE_NAME.tar

# Convert docker .tar-file to singularity container
# singularity build  macrosim_container.sif docker-archive://macrosim_image.tar
singularity build  CONTAINER_NAME.sif docker-archive://IMAGE_NAME.tar

#Run Singularity Container via:
# ./macrosim_container.sif python3 /dune/dune-microstructure/microstructure_testsuite/macro-problem-testsuite.py 1 #EXPERIMENT_id


# (Optional) Move Container to Barnard.
echo "Move to Barnard(HPC) ? " 

read HPC_flag 

if [ "$HPC_flag" == "true" ] || [ $HPC_flag -eq 1 ] || [ "$HPC_flag" == "yes" ]
then
    echo "Moving to Barnard..." 
    rsync CONTAINER_NAME.sif s7603593@dataport1.hpc.tu-dresden.de:/data/horse/ws/s7603593-microstructure
    rsync macrosim.batch  s7603593@dataport1.hpc.tu-dresden.de:/data/horse/ws/s7603593-microstructure
fi