import os
import sys
import re
import numpy as np
import matplotlib as mpl
import matplotlib.pyplot as plt
import matplotlib.colors as colors
from matplotlib import cm
from matplotlib.colors import ListedColormap, LinearSegmentedColormap


from matplotlib.ticker import LogLocator
import codecs

import json
import math
import subprocess
import fileinput
from matplotlib.ticker import MultipleLocator,FormatStrFormatter,MaxNLocator
from scipy.optimize import minimize_scalar 
import importlib

from microstructure_PythonAddons import *




# --------------------- Helper functions----------------------------------------------------------
# def energy(kappa,alpha,Q,B)  :
#     """
#         Energy evaluation for given effective quantities Q and B 
#         with input:
#         * curvature: kappa 
#         * angle: alpha
#     """
#     # --- TEST (This energy should be zero):
#     # B = np.array([1.0,0.0,0])
#     # kappa = 1.0
#     # alpha = 0
    
#     # print('Q:', Q)
#     # print('B:',B)
#     # print('kappa*np.array([[np.cos(alpha)**2],[np.sin(alpha)**2],[np.sqrt(2)*np.cos(alpha)*np.sin(alpha)]]):', kappa*np.array([[np.cos(alpha)**2],[np.sin(alpha)**2],[np.sqrt(2)*np.cos(alpha)*np.sin(alpha)]]))

#     # # G=(kappa*np.array([[np.cos(alpha)**2],[np.sin(alpha)**2],[np.sqrt(2)*np.cos(alpha)*np.sin(alpha)]]))-B
#     # G=kappa*np.array([[np.cos(alpha)**2],[np.sin(alpha)**2],[np.sqrt(2)*np.cos(alpha)*np.sin(alpha)]])-B
#     # print('G:',G)
#     # print('np.transpose(G):',np.transpose(G))
#     # print('np.matmul(Q,G)',np.matmul(Q,G))
#     # print('QUANTITY:', np.matmul(np.transpose(G),np.matmul(Q,G)))
#     # print('energy:', np.matmul(np.transpose(G),np.matmul(Q,G))[0,0])
#     # # return np.matmul(np.transpose(G),np.matmul(Q,G))[0,0]               #BUG: This is wrong!



#     #--- New Version (13-5-24)
#     # write kappa/alpha as minimizer which is a symmetric 2x2 matrix
#     # expressed in the canonical basis: 
#     # G = np.array(kappa*np.array([np.cos(alpha)**2, np.sin(alpha)**2, np.sqrt(2)*np.cos(alpha)*np.sin(alpha)]))
#     G = kappa*np.array([np.cos(alpha)**2, np.sin(alpha)**2, np.sqrt(2)*np.cos(alpha)*np.sin(alpha)])
#     print('G:',G)
#     G = G - B;


#     G_transposed = np.transpose(G);
#     # print('G:',G)
#     # print('G - B', G-B)
#     # print('G tranposed:', G_transposed)
#     # energyValue = G_transposed.dot((Q.dot(G)))
#     # # print('G_transposed.dot((Q.dot(G))): ', G_transposed.dot((Q.dot(G))))
#     # print('type(energyValue)', type(energyValue[0]))
    
#     return G_transposed.dot((Q.dot(G)));


#alternative version:
# def energy(kappa,alpha,Q,B)  :
#     G = np.array(kappa*np.array([np.cos(alpha)**2, np.sin(alpha)**2, np.sqrt(2)*np.cos(alpha)*np.sin(alpha)]))
#     G = G - B;

#     energy = 0.0

#     for i in range(0,2):
#         for j in range (0,2):
#             energy += Q[i][j]*G[i]*G[j]

#     print('energy: ', energy)
#     print('energy[0]: ', energy[0]) 
#     # print('type new: ', type(energy[0]))
#     return energy[0]





# def energy(kappa,alpha,Q,B)  :
#     """
#         Energy evaluation for given effective quantities Q and B 
#         with input:
#         * curvature: kappa 
#         * angle: alpha
#     """
#     # Compute cylindrical minimizer coefficients from angle & curvature
#     G = kappa*np.array([np.cos(alpha)**2, np.sin(alpha)**2, np.sqrt(2)*np.cos(alpha)*np.sin(alpha)])
#     # Subtract the effective prestrain
#     G = G - B;
#     # Compute the energy
#     energy =  (np.transpose(G)).dot((Q.dot(G)));
#     return energy

# def xytokappaalpha(x,y):
   
#     if y>0:
#         return [np.sqrt(x**2+y**2), np.abs(np.arctan2(y,x))]
#     else:
#         return [-np.sqrt(x**2+y**2), np.abs(np.arctan2(y,x))]

# # Read effective quantites
# def ReadEffectiveQuantities(QFilePath, BFilePath):
#     # Read Output Matrices (effective quantities)
#     # From Cell-Problem output Files : ../outputs/Qmatrix.txt , ../outputs/Bmatrix.txt
#     # -- Read Matrix Qhom
#     X = []
#     # with codecs.open(path + '/outputs/QMatrix.txt', encoding='utf-8-sig') as f:
#     with codecs.open(QFilePath, encoding='utf-8-sig') as f:
#         for line in f:
#             s = line.split()
#             X.append([float(s[i]) for i in range(len(s))])
#     Q = np.array([[X[0][2], X[1][2], X[2][2]],
#                   [X[3][2], X[4][2], X[5][2]],
#                   [X[6][2], X[7][2], X[8][2]] ])

#     # -- Read Beff (as Vector)
#     X = []
#     # with codecs.open(path + '/outputs/BMatrix.txt', encoding='utf-8-sig') as f:
#     with codecs.open(BFilePath, encoding='utf-8-sig') as f:
#         for line in f:
#             s = line.split()
#             X.append([float(s[i]) for i in range(len(s))])
#     B = np.array([X[0][2], X[1][2], X[2][2]])       # Beff is written as Coefficients to .txt-file
#     return Q, B



#     #--- Select specific experiment [x, y] with date from results_x/y
# def get_Q_B(basePath, index,perforation=False, perforatedLayer='upper'):
#     # results_index[0]/index[1]/...
#     #DataPath = './experiment/wood-bilayer_PLOS/results_'  + str(data[0]) + '/' +str(data[1])
#     # DataPath = './results_'  + str(index[0]) + '/' +str(index[1])
#     # DataPath = '.' + dirname + orientation + gridLevel + '/results_'  + str(index[0]) + '/' +str(index[1])
#     # DataPath = dirname + orientation + gridLevel + '/results_'  + str(index[0]) + '/' +str(index[1])
#     if perforation:
#         DataPath = basePath + '/results_'  +  perforatedLayer + '_'   + str(index[0]) + '/' +str(index[1])
#     else : 
#         DataPath = basePath + '/results_'  + str(index[0]) + '/' +str(index[1])

#     QFilePath = DataPath + '/QMatrix.txt'
#     BFilePath = DataPath + '/BMatrix.txt'
#     # Read Q and B
#     Q, B = ReadEffectiveQuantities(QFilePath,BFilePath)
#     Q=0.5*(np.transpose(Q)+Q) # symmetrize
#     B=np.transpose([B])
#     return (Q,B)




# def SetParameterMaterialFunction(inputFunction, parameterName, parameterValue):
#     with open(inputFunction+'.py', 'r') as file:
#         filedata = file.read()
#         filedata = re.sub('(?m)'+str(parameterName)+'\s?=.*',str(parameterName)+' = '+str(parameterValue),filedata)
#         f = open(inputFunction+'.py','w')
#         f.write(filedata)
#         f.close()







# def createEnergyValues(r,theta,Q,B):
#     """
#         Compute energy values for a given meshgrid of curvature(r) and angle(theta) values
#         associated to the effective quantities Q and B.

#         the curvature array 'r' only features positive values. However the energy is also 
#         evaluated for the corresponding negative values.
#     """
            
#     # Get number of sample points.
#     N = r.shape[0]

#     E=np.zeros(np.shape(r))
#     for k in range(0,N): 
#         for l in range(0,N):     
#             if theta[k,l]<np.pi:
#                 E[k,l]=energy(r[k,l],theta[k,l],Q,B)
#             else:
#                 E[k,l]=energy(-r[k,l],theta[k,l],Q,B)

#     return E


# def getMinimizers(r,theta,E):
#     """"
#         Compute global minimizer (by Sampling method)
#         as well as the minimizer on the opposite sign - curvature scale

#         E: meshgrid evaluation of energy.
#     """
#     kappa=0
#     kappa_pos=0
#     kappa_neg=0


#     N = E.shape[0]
#     # Compute global Minimizer 
#     [kmin,lmin]=np.unravel_index(E.argmin(),(N,N))
#     kappamin=r[kmin,lmin]
#     alphamin=theta[kmin,lmin]
#     Emin = E[kmin,lmin]

#     # Get minimizer in Positive curvature region
#     N_mid=int(N/2)
#     [kmin,lmin]=np.unravel_index(E[:N_mid,:].argmin(),(N_mid,N))
#     kappamin_pos=r[kmin,lmin]
#     alphamin_pos=theta[kmin,lmin]
#     Emin_pos=E[kmin,lmin]
#     # Get minimizer in Negative curvature region
#     [kmin,lmin]=np.unravel_index(E[N_mid:,:].argmin(),(N_mid,N))
#     kappamin_neg=r[kmin+N_mid,lmin]
#     alphamin_neg=theta[kmin+N_mid,lmin]
#     Emin_neg=E[kmin+N_mid,lmin]

#     print('Emin:', Emin)
#     print('Emin_pos:', Emin_pos)
#     print('Emin_neg:', Emin_neg)
#     print('energy in origin (0,0):' ,energy(0,0,Q,B))
#     print('E.min(): ',E.min())
#     print('E.max(): ',E.max())

#     minimizer_sign = 'positive'

#     if(abs(Emin_pos - Emin_neg)<1e-5):
#         print('Both minimizers have nearly the same energy - likely two minimizers.')
#     elif(Emin_pos < Emin_neg):
#         print('Global Minimizer has positive curvature.')
#         energyDifference = Emin_neg-Emin_pos
#     else:
#         print('Global Minimizer has negative curvature.')
#         minimizer_sign = 'negative'
#         energyDifference = Emin_pos-Emin_neg


#     if (minimizer_sign == 'positive'):
#         alpha_globalmin = alphamin
#         kappa_globalmin = kappamin
#         kappa_localmin = (-1)*kappamin_neg 
#         alpha_localmin = alphamin_neg
#     else :
#         alpha_globalmin = alphamin
#         kappa_globalmin = (-1)*kappamin
#         kappa_localmin = kappamin_pos
#         alpha_localmin = alphamin_pos

#     print('kappa_globalmin: ', kappa_globalmin)
#     print('alpha_globalmin: ', alpha_globalmin)
#     print('kappa_localmin: ',  kappa_localmin)
#     print('alpha_localmin: ',  alpha_localmin)
#     print('energy (global minimizer)', energy(kappa_globalmin,alpha_globalmin,Q,B))
#     print('energy (local minimizer)', energy(kappa_localmin,alpha_localmin,Q,B))

#     return [kappa_globalmin,alpha_globalmin,kappa_localmin,alpha_localmin,energyDifference,minimizer_sign];




# def createEnergyLandscapeFigure(r,theta,E,title_string='',normalize=True):
#     """
#         Create an energy landscape plot.
#     """
#     print('create energy landscape ...')

#     #Get Minimzers from sampled energy values.
#     [kappa_globalmin,alpha_globalmin,kappa_localmin,alpha_localmin,energyDifference,minimizer_sign] = getMinimizers(E) 

#     # Normalize minimum energy to zero:
#     if normalize:
#         E=E-E.min()
#         print('E.min(): (after normalization): ',E.min())
#         print('E.max(): (after normalization): ',E.max())

#     levs=np.geomspace(0.01,E.max(),300)  # Return numbers spaced evenly on a log scale (a geometric progression).
 
#     fig, ax1 = plt.subplots(ncols=1,nrows=1, figsize=(width,height), subplot_kw=dict(polar=True),gridspec_kw={'hspace': 0.4}, zorder=1)
#     fig.subplots_adjust(left=.1, bottom=0.01, right=.9, top=0.9)  #adjust placement inside figure

#     """
#         Define new custom colormap (Test)
#         define top and bottom colormaps 
#     """
#     # top = cm.get_cmap('Oranges_r', 128) # r means reversed version
#     # bottom = cm.get_cmap('Blues', 128)# combine it all
#     # newcolors = np.vstack((top(np.linspace(0, 1, 128)),
#     #                     bottom(np.linspace(0, 1, 128))))
#     # orange_blue = colors.ListedColormap(newcolors, name='OrangeBlue')
#     # bi_pride = LinearSegmentedColormap.from_list("", ["#D60270", "#9B4F96", "#0038A8"])
#     # testColor = LinearSegmentedColormap.from_list("", ["#380282","#0343DF","#FF7F50",  "#FE420F"])

#     """
#         Plot with 'contourf':
#         Its important to hide the Contour LineStroke (remove white lines between contour levels) using set_edgecolor("face")
#     """
#     # pcm=ax1.contourf(theta, r, E, levs, norm=colors.PowerNorm(gamma=0.5,vmin=E.min(),vmax=E.max()), cmap='brg', zorder=0)
#     # for c in pcm.collections:
#     #   c.set_edgecolor("face")

#     """
#         Plot with 'pcolormesh'
#         * Reducing the image-quality/file-size by using rasterized option:
#         * Looks much smoother without 'rasterize' option however file-size gets out of hand..: 
#         * Together with the 'dpi=..' option of figsave we can control the file-size
#         * Advantage: Text etc. is still vectorized without having too large files.

#         Problem: How to get the Colorbarticks  in a uniform spacing when using PowerNorm (unclear)
#     """
#     pcm=ax1.pcolormesh(theta, r, E, norm=colors.PowerNorm(gamma=0.4,vmin=E.min(),vmax=E.max()) ,cmap='plasma', edgecolors='face', zorder=0, rasterized=True, alpha=0.8) 



#     print('0.025*E.max():',0.025*E.max())
#     print('energyDifference: ', energyDifference)

#     """"
#         Create additional contour-line plot in the range between
#         zero and the energyDifference between both minimizers.
#     """
#     contour_levs = np.linspace(0.0001,energyDifference*1.0,6) # contour only from zero (Minimizer) to energyDifference between global/local Minimizer.
#     print('contour_levs:', contour_levs)
#     contours = plt.contour(theta, r, E, contour_levs, norm=colors.PowerNorm(gamma=0.4,vmin=E.min(),vmax=E.max()), colors='ivory',linewidths=0.65, linestyles="dashed", alpha=0.8, zorder=2)
#     contours_min = plt.contour(theta, r, E, [contour_levs[1]], norm=colors.PowerNorm(gamma=0.4,vmin=E.min(),vmax=E.max()), colors='yellow',linewidths=0.65, linestyles="solid", alpha=0.9, zorder=2)

#     # Set Title.
#     ax1.set_title(title_string,pad=6)
#     # ax1.set_title(r"ratio $r=0.12$",pad=6)
#     # ax1.set_title(r""+parameterName + ": " + str(parameterValue),pad=20)


#     # Create a string if the minimal angle,curvature values used to label the global minimizer.
#     Minimizer_string = ': (' + str(np.round(np.rad2deg(alpha_globalmin),decimals=1)) + '°,' + str(np.round(abs(kappa_globalmin),decimals=2))+ ')'


#     # Mark Global Minimizer.
#     gmin = ax1.plot(alpha_globalmin, abs(kappa_globalmin),
#                     markerfacecolor='cornflowerblue',
#                     markeredgecolor='white',            # marker edgecolor
#                     marker='o',                         # each marker will be rendered as a circle
#                     markersize=6,                       # marker size
#                     markeredgewidth=1.0,                  # marker edge width
#                     linewidth=0,
#                     zorder=3,
#                     alpha=1,                           # Change opacity
#                     label = Minimizer_string)   
    

#     plot_minimizerInOppositeCurvatureRegion = False     #Note: this is not necessarily a local minimizer!
        

#     if plot_minimizerInOppositeCurvatureRegion:
#             ax1.plot(alpha_localmin, abs(kappa_localmin),   # We need to take abs(kappa) since negative curvatures are still plotted with a positive kappa!
#                         markerfacecolor='green',    
#                         markeredgecolor='white',            # marker edgecolor
#                         marker='D',                         # each marker will be rendered as a circle
#                         markersize=4,                       # marker size
#                         markeredgewidth=0.5,                  # marker edge width
#                         linewidth=0,                      # line width
#                         zorder=3,
#                         alpha=1)
            

#             # #--- annotate local minimizer
#             # ax1.annotate( '('+ str(np.round(360-np.rad2deg(alpha_localmin),decimals=1)) + '°' + ',' + str(np.round(kappa_localmin,decimals=2))+ ')' ,
#             #             xy = (alpha_localmin,abs(kappa_localmin)),
#             #             # xytext=(-1.6, np.round(kappa_localmin,decimals=2)+0.9),
#             #             # xytext=(-1.6, np.round(kappa_localmin,decimals=2)),
#             #             xytext=(alpha_localmin,abs(kappa_localmin)),
#             #             color='ivory',
#             #             # zorder=5,
#             #             fontsize='8')

#     print('Global Minimizer (alphamin, kappamin):' , '('+ str(np.round(np.rad2deg(alpha_globalmin),decimals=1)) + ',' + str(np.round(abs(kappa_globalmin),decimals=2))+ ')' ) 
#     print('Local Minimizer opposite curvature (alphamin, kappamin):' , '('+ str(np.round(360-np.rad2deg(alpha_localmin),decimals=1)) + ',' + str(np.round(abs(kappa_localmin),decimals=2))+ ')' ) 

#     #### Colorbar for Contourf-Plot:
#     # colorbarticks=np.geomspace(0.00001,E.max(),10)
#     # cbar = plt.colorbar(pcm, ax=[ax1], extend='max', ticks=colorbarticks, pad=0.1, orientation="horizontal")

#     # Colorbar for pcolormesh-Plot:
#     cbar = fig.colorbar(pcm, ax=ax1, pad=0.1,  orientation="horizontal") 


#     """
#         Set Tick labels
#         x: Angle 
#         y: Radius
    
#     """
#     anglelabel=["0°","45°", "90°", "135°", "180°","-135°","-90°","-45°"]
#     # anglelabel=["0°","45°", "90°", "135°",r"$\pm180$° ","-135°","-90°","-45°"]
#     ax1.set_xticks(np.array([.0,1/4,2/4,3/4,1,5/4,6/4,7/4])*np.pi)
#     ax1.set_xticklabels(anglelabel)
#     # ax1.xaxis.grid(True, color='white')
#     ax1.xaxis.grid(True)
#     # We want to grid-axis to be on top of the contour lines to hide confusing contours on the grid-axis.
#     ax1.set_axisbelow(False)

#     # Adjust pad of xticklabels:
#     ax1.tick_params(pad=0.5)

#     # rotate radius axis labels.
#     ax1.set_rlabel_position(225)

#     # Adjust radial ticks.
#     radiusTickLength = 0.5
#     ax1.yaxis.set_major_locator(plt.FixedLocator(np.arange(radiusTickLength,curvatureLength,radiusTickLength)))
#     # (Alternative used fixed values)
#     # ax1.set_yticks(np.array([1,2,3]))
#     # ax1.set_yticklabels(["1","2","3"], zorder=20, color="white")
#     ax1.yaxis.set_tick_params(color='white', pad = 1.0)
#     ax1.yaxis.grid(True)

#     # Create Minor ticks manually as polar coordinates does not have the option.
#     tick = [ax1.get_rmax(),ax1.get_rmax()*0.97]
#     for t  in np.deg2rad(np.arange(0,360,5)):
#         ax1.plot([t,t], tick, lw=0.1, color="k")


#     # Create a Legend.
#     legend = ax1.legend(bbox_to_anchor=[0.75, 0.15],loc='lower center',borderaxespad=0.1,frameon=True,bbox_transform=fig.transFigure,handletextpad=0.1)
#     frame = legend.get_frame()
#     frame.set_edgecolor('black')

#     # Save Figure as png.
#     # fig.savefig(resultPath + '/energy_landscape_'+ parameterName + '_' +str(parameterValue) + '.png', dpi=100)
#     # Save Figure as pdf.
#     fig.set_size_inches(width, height)
#     fig.savefig(resultPath + '/energy_landscape_'+ parameterName + '_' +str(parameterValue) + '.pdf', dpi=500) #dpi on
#     return


# -------------------------- Matplotlib - parameters.--------------------------------------------------------------
# plt.style.use("seaborn")
# plt.style.use('paperstyle.mplstyle')

#reset to default style-sheet_
# plt.style.use('default')


# plt.style.use("seaborn")

# mpl.rcParams['text.usetex'] = True
# mpl.rcParams["font.family"] = "serif"
# mpl.rcParams["font.size"] = "8"
# mpl.rcParams['xtick.bottom'] = True
# mpl.rcParams['xtick.major.size'] = 2
# mpl.rcParams['xtick.minor.size'] = 1.5
# mpl.rcParams['xtick.major.width'] = 0.75
# # mpl.rcParams['xtick.labelsize'] = 8
# mpl.rcParams['xtick.major.pad'] = 0.1
# mpl.rcParams['ytick.left'] = True
# mpl.rcParams['ytick.major.size'] = 2
# mpl.rcParams['ytick.minor.size'] = 1.5
# mpl.rcParams['ytick.major.width'] = 0.75
# mpl.rcParams['ytick.labelsize'] = 8
# mpl.rcParams['ytick.major.pad'] = 1
# mpl.rcParams['axes.titlesize'] = 8
# mpl.rcParams['axes.titlepad'] = 1
# # mpl.rcParams['axes.labelsize'] = 8
# #Adjust Legend:
# mpl.rcParams['legend.frameon'] = True       # Use frame for legend
# # mpl.rcParams['legend.framealpha'] = 0.5 
# mpl.rcParams['legend.fontsize'] = 8         # fontsize of legend
# #Adjust grid:
# # mpl.rcParams.update({"axes.grid" : True}) # Add grid
# mpl.rcParams.update({"axes.grid" : False}) # Add grid
# mpl.rcParams['axes.labelpad'] = 3
# mpl.rcParams['grid.linewidth'] = 0.25
# mpl.rcParams['grid.alpha'] = 0.75 # 0.75
# mpl.rcParams['grid.linestyle'] = '-'
# mpl.rcParams['grid.color']   = 'lightgray'#'black'
# mpl.rcParams['text.latex.preamble'] = r'\usepackage{amsfonts}' # Makes Use of \mathbb possible.


# plt.style.use("seaborn")
# plt.style.use('paperstyle.mplstyle')
# textwidth = 6.26894 #textwidth in inch
# width = textwidth * 0.5
# # width = textwidth * 0.33
# # width = textwidth 
# # height = width/1.618 # The golden ratio.
# height = textwidth/1.618 # The golden ratio.
# # height = width
# # height = width*1.618
# ------------------------------------------------------------------------------------------------------------------


# ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
# ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
computeEffectiveQuantities = True
computeEffectiveQuantities = False
plotEnergyLandscape_flag = True
plotEnergyLandscape_flag = False
displayMinimizer = False 
displayMinimizer = True

plotContourLines = True
# plotContourLines = False


plotCurvatureAngleParameterDependence_flag = True
# plotCurvatureAngleParameterDependence_flag = False

plotPrestrainParameterDependence_flag = True
plotPrestrainParameterDependence_flag = False

N=2000 #Number of Sampling Points
curvatureLength=2.5
# N=1000 #Number of Sampling Points
N=500 #Number of Sampling Points
# curvatureLength=5

# 1. Experiment   2. ExperimentPathExtension   3. MicroGridLevels, 4. Executable 5.(additional) parameterArray: [["ParameterName", ParameterValue], ...]
scenarios = [
                ["prestrainedFibre",            "/micro-problem",  [3,3], "/micro-problem"  , [["verticalMidpointPosition", [0,0.05,0.1,0.15,0.2,0.25]]] ],  #0
                ["prestrainedFibre",            "/micro-problem",  [3,3], "/micro-problem"  , [["fibreRadius", [0,0.05,0.1,0.15,0.2,0.25]]] ],               #1
                ["prestrainedFibre_anisotropicB","/micro-problem",  [3,3], "/micro-problem"  , [["mu_phase1", [100]]] ],                                     #2
                ["prestrainedFibre_anisotropicQ","/micro-problem",  [3,3], "/micro-problem"  , [["mu_phase1", [100]]] ],                                     #3
                ["prestrainedFibre",            "/micro-problem",  [3,3], "/micro-problem"  , [["mu_phase1", [100]]] ],                                      #4
                ["prestrainedFibre",            "/micro-problem",  [3,3], "/micro-problem"  , [["mu_phase1", [50,150]]] ],                                   #5
                ["prestrainedFibre",            "/micro-problem",  [3,3], "/micro-problem"  , [["mu_phase1", [75]]] ],                                       #6
                # ["three-phase-composite",                                  "",  [3,3], "/micro-problem"  , [["mu_phase1", [0.1,1,63.89,200]]] ],
                ["three-phase-composite",       "/micro-problem",  [3,3], "/micro-problem"  , [["rho", [0,0.25,0.5,0.75,1.0,2.0]]] ], #Figure:...            #7
                ["three-phase-composite",       "/micro-problem",  [3,3], "/micro-problem"  , [["rho", [0.95]]] ], #Figure:...                               #8
                ["three-phase-composite",       "/micro-problem",  [3,3], "/micro-problem"  , [["rho", [1.0]]] ], #Figure:...                                #9
                ["two-phase-composite",         "/micro-problem",  [3,3], "/micro-problem"  , [["rho", [0.5]]] ], #Figure:...                                #10
                ["buckling_microproblem",       "/micro-problem",  [3,3], "/micro-problem"  , [["rho", [0.0]]] ], #Figure:...                        #11
                ["buckling_microproblem",       "/micro-problem",  [3,3], "/micro-problem"  , [["rho", [x/10.0 for x in range(1,11,1)]]] ], #Figure:...      #12
                # ["three-phase-composite",                                             "",  [4,4], "/micro-problem"  ,         [["rho", [1.0]]]    ],
                ["parametrized_laminate",       "/micro-problem",  [3,3], "/micro-problem"  ,  [["theta_mu", [0.5,1.0,10.0]]]            ],
                ["parametrized_laminate",       "/micro-problem",  [3,3], "/micro-problem"  ,  [["theta_rho", [0.1,0.2,0.25,0.5,1.0,2.0,10.0]]]],
                ["parametrized_laminate",       "/micro-problem",  [3,3], "/micro-problem"  ,  [["theta_rho", [0.1]]]            ]
            ]


print('sys.argv[0]', sys.argv[0])
print('sys.argv[1]', sys.argv[1])
print('sys.argv[2]', sys.argv[2])


print('list(range(0,1,0.1)):',[x/10.0 for x in range(0,11,1)])



CONTAINER = int(sys.argv[1])
slurm_array_task_id = int(sys.argv[2])

parameterFile  = scenarios[slurm_array_task_id][0]
pathExtension  = scenarios[slurm_array_task_id][1]
gridLevels     = scenarios[slurm_array_task_id][2]
executable     = scenarios[slurm_array_task_id][3]
parameterArray = scenarios[slurm_array_task_id][4]

#Test 
# parameterArray = [[" -rho ", [4.0]]] 


print('pathExtension: ', pathExtension)



#Get current working directory:
# cwd = os.getcwd()
modulePath = os.path.abspath(os.path.join(os.getcwd(), os.pardir))
print("Parent Directory is: ", modulePath)


#Path for parameterFile
if CONTAINER:
    #--- Barnard/CONTAINER version
    pythonPath = "/dune/dune-microstructure/experiment" + pathExtension
    resultPath = "outputs" + "_" + scenarios[slurm_array_task_id][0]
    instrumentedPath =  resultPath + "/instrumented" 
    executablePath = "/dune/dune-microstructure/build-cmake/src"
else :
    #--- Local version
    pythonPath =  modulePath + "/experiment" + pathExtension
    resultPath = modulePath + "/outputs" + "_" + scenarios[slurm_array_task_id][0]
    instrumentedPath = resultPath + "/instrumented"
    executablePath = modulePath + '/build-cmake/src'

try:
    os.mkdir(resultPath)
    os.mkdir(instrumentedPath)
except OSError as error:
    print(error)

print('pythonPath: ', pythonPath)


### Access ParameterFile variables.
sys.path.insert(0, pythonPath)
__import__(parameterFile, fromlist=['parameterSet'])
imported_module = importlib.import_module(parameterFile)
parameterSet = getattr(imported_module, "parameterSet")

executable = executablePath + executable

resultPathBase = resultPath






#----------------------------------------------------------------------------------------------------------------------
if computeEffectiveQuantities: 
    print('Computing effective quantities... ')
    for i in range(0, len(parameterArray)):
        for v in range(0,len(parameterArray[i][1])):
            print("------------------")
            print("New Loop")
            print("------------------")
            print('i:', i)
            print('v:', v)
            print('len(parameterArray[i][1]):', len(parameterArray[i][1]))
            # print('parameterArray[i][v]:', parameterArray[i][v])

            print('parameterName:'  , parameterArray[i][0])
            print('parameterValue: ', parameterArray[i][1][v])
            # print('np.shape(parameterArray)[1]:', np.shape(parameterArray)[1])
            # print('np.shape(parameterArray[i][1]):', np.shape(parameterArray[i][1]))
            # print('np.shape(parameterArray[i][1])[1]:', np.shape(parameterArray[i][1])[1])
            parameterName =  parameterArray[i][0]
            parameterValue = parameterArray[i][1][v]


            resultPath_parent = resultPathBase + "/" + parameterName
            resultPath = resultPath_parent + "/value_" + str(parameterValue)
            try:
                os.mkdir(resultPath_parent)
            except OSError as error:
                print("")
                # print(error)
            try:
                os.mkdir(resultPath)
            except OSError as error:
                print("")
                # print(error)
            



            ## Alternative version: actually changing the parset file..
            # Change Parameters:
            print('...change input parameter:' , parameterName)
            SetParameterMaterialFunction(pythonPath + "/" + scenarios[slurm_array_task_id][0], parameterName , parameterValue)


            baseName = scenarios[slurm_array_task_id][0] + "_" + parameterArray[i][0] + "_" +  str(parameterArray[i][1][v])

            #--- Compute 
            processList = []
            for microGridLevel in range(gridLevels[0],gridLevels[1]+1):
                # if conforming_DiscreteJacobian:
                #     conformity = "_conforming"
                # else:
                #     conformity = "_nonconforming"

                # LOGFILE = resultPath + "/" + parameterFile + conformity + "_macroGridLevel" + str(macroGridLevel) + parameterName  + ".log"
                LOGFILE = resultPath + "/" + parameterFile  + "_microGridLevel" + str(microGridLevel) + "_" + parameterName + "_" + str(parameterValue) + ".log"

                print('LOGFILE:', LOGFILE)
                print('executable:', executable)
                print('parameterFile:', parameterFile)
                print('resultPath:', resultPath)

                # testArray = [ " -rho " + str(8.0), " -beta " + str(0.10) ]

                # start_time = time.time()
                p = subprocess.Popen(executable + " " + pythonPath + " " + parameterFile
                                                + " -microGridLevel " + str(microGridLevel)
                                                + " -resultPath " + str(resultPath)
                                                + " -baseName " + str(baseName)
                                                # + " -" + parameterName + " " + str(parameterValue)
                                                + " | tee " + LOGFILE, shell=True)

                p.wait() # wait
                # print("--- %s seconds ---" % (time.time() - start_time))
                print('------FINISHED PROGRAM on macroGridLevel:' + str(microGridLevel))
                processList.append(p)

                # Wait for all simulation subprocesses before proceeding to the error measurement step
                exit_codes = [p.wait() for p in processList]




# print('parameterArray:', parameterArray)
# print('len(parameterArray):',           len(parameterArray))
# print('len(parameterArray[0][1]): ', len(parameterArray[0][1]))
# print('Number of different additional parameters:', len(parameterArray))

#----------------------------------------------------------------------------------------------------------------------
if plotPrestrainParameterDependence_flag:
    print('Plot Prestrain - Parameter dependence ...')
    inputValues = []
    outputValues_b1 = []
    outputValues_b2 = []
    outputValues_b3 = []
    for i in range(0, len(parameterArray)):
        for v in range(0,len(parameterArray[i][1])):
            print("------------------")
            print("New Loop")
            print("------------------")
            print('i:', i)
            print('v:', v)
            print('len(parameterArray[i][1]):', len(parameterArray[i][1]))

            print('parameterName:'  , parameterArray[i][0])
            print('parameterValue: ', parameterArray[i][1][v])
            parameterName =  parameterArray[i][0]
            parameterValue = parameterArray[i][1][v]

            resultPath_parent = resultPathBase + "/" + parameterName
            resultPath = resultPath_parent + "/value_" + str(parameterValue)


            try:
                os.mkdir(resultPath_parent)
            except OSError as error:
                print("")
                # print(error)
            try:
                os.mkdir(resultPath)
            except OSError as error:
                print("")
                # print(error)

            # Set Path for effective quantitites.
            QFilePath = resultPath + "/QMatrix.txt"
            BFilePath = resultPath + "/BMatrix.txt"

            # Read the effective quantities from .txt-File
            Q, B = ReadEffectiveQuantities(QFilePath,BFilePath)
            print('Qhom: \n', Q)
            print('Beff: \n', B)
            # Test: symmetrize Qhom
            # Q=0.5*(np.transpose(Q)+Q) # symmetrize


            # N=1000 #Number of Sampling Points
            # curvatureLength=1
            # r, theta = np.meshgrid(np.linspace(0,curvatureLength,N),np.radians(np.linspace(0, 360, N)))

            # E = createEnergyValues(r,theta,Q,B)

            # """"
            #     Create the energy landscape from the dataset E.
            #     If 'Normalize' is set to true the energy is normalized via
            #     E=E-E.min()
            # """
            # # title_string = r"ratio $r=0.12$"
            # # title_string = r""+parameterName + ": " + str(parameterValue)
            # # title_string = ''
            # # createEnergyLandscapeFigure(r,theta,E,curvatureLength,Q,B,resultPath,parameterName,parameterValue,title_string,True)
            # # createEnergyLandscapeFigure(r,theta,E,resultPath,parameterName,parameterValue,title_string,True)
            # # createEnergyLandscapeFigure(r,theta,E,resultPath,parameterName,parameterValue,title_string,True,displayMinimizer)

            # [kappa_globalmin,alpha_globalmin,kappa_localmin,alpha_localmin,energyDifference,minimizer_sign] = getMinimizers(r,theta,E) 

            inputValues.append(parameterValue)

            outputValues_b1.append(B[0])
            outputValues_b2.append(B[1])
            outputValues_b3.append(B[2])
            # ---------------------------------------------------------------------------------------------------------



        #--- Create Plot ...
        # Setup Plot style.
        plt.style.use("seaborn")
        # plt.style.use('paperstyle.mplstyle')
        # Set correct Figure size (width/height) to make the figure fit the text without scaling.
        textwidth = 6.26894      # textwidth in inch
        width = textwidth * 0.5
        # height = textwidth/1.618 # The golden ratio.
        # height = width/1.618 # The golden ratio.
        height = width


        #---------TEST
        # Styling
        plt.style.use("seaborn-darkgrid")
        # plt.style.use("seaborn-whitegrid")
        # plt.style.use("seaborn")
        # plt.style.use("seaborn-paper")
        # plt.style.use('ggplot')
        # plt.rcParams["font.family"] = "Avenir"
        # plt.rcParams["font.size"] = 16

        # plt.style.use("seaborn-darkgrid")
        mpl.rcParams['text.usetex'] = True
        mpl.rcParams["font.family"] = "serif"
        mpl.rcParams["font.size"] = "10"
        # mpl.rcParams['xtick.labelsize'] = 16mpl.rcParams['xtick.major.size'] = 2.5
        # mpl.rcParams['xtick.bottom'] = True
        # mpl.rcParams['ticks'] = True
        mpl.rcParams['xtick.bottom'] = True
        mpl.rcParams['xtick.major.size'] = 3
        mpl.rcParams['xtick.minor.size'] = 1.5
        mpl.rcParams['xtick.major.width'] = 0.75
        mpl.rcParams['ytick.left'] = True
        mpl.rcParams['ytick.major.size'] = 3
        mpl.rcParams['ytick.minor.size'] = 1.5
        mpl.rcParams['ytick.major.width'] = 0.75

        mpl.rcParams.update({'font.size': 10})
        mpl.rcParams['axes.labelpad'] = 3
        #---------------------

        # Create a figure & axes object
        # fig, ax1 = plt.subplots(ncols=1,nrows=1, figsize=(width,height),gridspec_kw={'hspace': 0.4}, zorder=1)
        fig, ax1 = plt.subplots(ncols=1,nrows=1, figsize=(width,height), zorder=1)
        # title_string = r"$B_1$" + "-" r""+parameterName 
        title_string = ''
        # ax1.set_title(title_string,pad=6)


        print('plot curvature over parameter -'+ parameterName)
        print('inputValues:', inputValues)
        print('outputValues:', outputValues_b1)
        print('outputValues:', outputValues_b2)
        print('outputValues:', outputValues_b3)

        l1 = ax1.plot(inputValues,outputValues_b1 ,
                        label=r"$\widehat{B}^h_1$" ,
                        markerfacecolor='orange',
                        markeredgecolor='white',            # marker edgecolor
                        marker='o',                         # each marker will be rendered as a circle
                        markersize=6,                       # marker size
                        markeredgewidth=1.0,                  # marker edge width)
                        linewidth=1.5
                     )
        l2 = ax1.plot(inputValues,outputValues_b2 ,
                      label=r"$\widehat{B}^h_2$",
                    #   markerfacecolor='orange',
                      markeredgecolor='white',            # marker edgecolor
                      marker='s',                         # each marker will be rendered as a circle
                      markersize=6,                       # marker size
                      markeredgewidth=1.0,                  # marker edge width)
                      linewidth=1.5
                     )
        l3 = ax1.plot(inputValues,outputValues_b3 , 
                      label=r"$\widehat{B}^h_3$",
                    #   markerfacecolor='orange',
                      markeredgecolor='white',            # marker edgecolor
                      marker='^',                         # each marker will be rendered as a circle
                      markersize=6,                       # marker size
                      markeredgewidth=1.0,                  # marker edge width)
                      linewidth=1.5
                     )

        legend = ax1.legend()
        # legend = ax1.legend(bbox_to_anchor=[0.75, 0.15],loc='lower center',borderaxespad=0.1,frameon=True,bbox_transform=fig.transFigure,handletextpad=0.1)
        # frame = legend.get_frame()
        # frame.set_edgecolor('black')

        ## PUT LEGEND ON BOTTOM /TOP
        # legend = fig.legend([l1, l2, l3],     # The line objects
        #         # labels=line_labels,   # The labels for each line
        #         loc="lower left",   # Position of legend
        #         # bbox_to_anchor=[1.0, 0.55],
        #         # bbox_to_anchor=[0.1, 1.0], # TOP
        #         # bbox_to_anchor=[0.1, -0.15], # BOTTOM
        #         bbox_to_anchor=[0.125, -0.15], # BOTTOM
        #         borderaxespad=0.15,    # Small spacing around legend box
        #         frameon=True,
        #         ncol = 4

        #         # title="Legend Title"  # Title for the legend
        #         )

        # frame = legend.get_frame()
        # # frame.set_color('white')
        # frame.set_edgecolor('gray')

        #Test:tight Layout
        plt.tight_layout()



        fig.set_size_inches(width, height)
        fig.savefig(resultPath_parent + '/PrestrainDependence_' + '_' + parameterName +  '.pdf', dpi=1500) #dpi on
#----------------------------------------------------------------------------------------------------------------------
if plotCurvatureAngleParameterDependence_flag:
    print('Plot Curvature/Angle Parameter dependence ...')
    inputValues = []
    outputValues_curvature = []
    outputValues_angle = []
    # outputQuantity = 'curvature'
    for i in range(0, len(parameterArray)):
        for v in range(0,len(parameterArray[i][1])):
            print("------------------")
            print("New Loop")
            print("------------------")
            print('i:', i)
            print('v:', v)
            print('len(parameterArray[i][1]):', len(parameterArray[i][1]))

            print('parameterName:'  , parameterArray[i][0])
            print('parameterValue: ', parameterArray[i][1][v])
            parameterName =  parameterArray[i][0]
            parameterValue = parameterArray[i][1][v]

            resultPath_parent = resultPathBase + "/" + parameterName
            resultPath = resultPath_parent + "/value_" + str(parameterValue)


            try:
                os.mkdir(resultPath_parent)
            except OSError as error:
                print("")
                # print(error)
            try:
                os.mkdir(resultPath)
            except OSError as error:
                print("")
                # print(error)

            # Set Path for effective quantitites.
            QFilePath = resultPath + "/QMatrix.txt"
            BFilePath = resultPath + "/BMatrix.txt"

            # Read the effective quantities from .txt-File
            Q, B = ReadEffectiveQuantities(QFilePath,BFilePath)
            print('Qhom: \n', Q)
            print('Beff: \n', B)
            # Test: symmetrize Qhom
            # Q=0.5*(np.transpose(Q)+Q) # symmetrize


            # N=1000 #Number of Sampling Points
            # curvatureLength=1
            r, theta = np.meshgrid(np.linspace(0,curvatureLength,N),np.radians(np.linspace(0, 360, N)))

            E = createEnergyValues(r,theta,Q,B)

            """"
                Create the energy landscape from the dataset E.
                If 'Normalize' is set to true the energy is normalized via
                E=E-E.min()
            """
            # title_string = r"ratio $r=0.12$"
            # title_string = r""+parameterName + ": " + str(parameterValue)
            # title_string = ''
            # createEnergyLandscapeFigure(r,theta,E,curvatureLength,Q,B,resultPath,parameterName,parameterValue,title_string,True)
            # createEnergyLandscapeFigure(r,theta,E,resultPath,parameterName,parameterValue,title_string,True)
            # createEnergyLandscapeFigure(r,theta,E,resultPath,parameterName,parameterValue,title_string,True,displayMinimizer)

            [kappa_globalmin,alpha_globalmin,kappa_localmin,alpha_localmin,energyDifference,minimizer_sign] = getMinimizers(r,theta,E) 

            inputValues.append(parameterValue)

            outputValues_curvature.append(kappa_globalmin)
            outputValues_angle.append(alpha_globalmin)

            # if outputQuantity == 'curvature':

            #     outputValues.append(kappa_globalmin)

            # elif outputQuantity == 'angle':
            #     print('plot angle over parameter -' + parameterName)
            #     outputValues.append(alpha_globalmin)
            # else :
            #     raise Exception("Only Curvature & Angle - parameter dependence can be plotted so far.")
            # ---------------------------------------------------------------------------------------------------------



    #--- Create Plot ...
    # Setup Plot style.
    plt.style.use("seaborn")
    # plt.style.use('paperstyle.mplstyle')
    # Set correct Figure size (width/height) to make the figure fit the text without scaling.
    textwidth = 6.26894      # textwidth in inch
    width = textwidth * 0.5
    # height = textwidth/1.618 # The golden ratio.
    # height = width/1.618 # The golden ratio.
    height = width


    #---------TEST
    # Styling
    plt.style.use("seaborn-darkgrid")
    # plt.style.use("seaborn-whitegrid")
    # plt.style.use("seaborn")
    # plt.style.use("seaborn-paper")
    # plt.style.use('ggplot')
    # plt.rcParams["font.family"] = "Avenir"
    # plt.rcParams["font.size"] = 16

    # plt.style.use("seaborn-darkgrid")
    mpl.rcParams['text.usetex'] = True
    mpl.rcParams["font.family"] = "serif"
    mpl.rcParams["font.size"] = "10"
    # mpl.rcParams['xtick.labelsize'] = 16mpl.rcParams['xtick.major.size'] = 2.5
    # mpl.rcParams['xtick.bottom'] = True
    # mpl.rcParams['ticks'] = True
    mpl.rcParams['xtick.bottom'] = True
    mpl.rcParams['xtick.major.size'] = 3
    mpl.rcParams['xtick.minor.size'] = 1.5
    mpl.rcParams['xtick.major.width'] = 0.75
    mpl.rcParams['ytick.left'] = True
    mpl.rcParams['ytick.major.size'] = 3
    mpl.rcParams['ytick.minor.size'] = 1.5
    mpl.rcParams['ytick.major.width'] = 0.75

    mpl.rcParams.update({'font.size': 10})
    mpl.rcParams['axes.labelpad'] = 3
    #---------------------

    #----------------------------------------
    #--- Curvature-Plot:
    # Create a figure & axes object
    # fig, ax1 = plt.subplots(ncols=1,nrows=1, figsize=(width,height),gridspec_kw={'hspace': 0.4}, zorder=1)
    fig, ax1 = plt.subplots(ncols=1,nrows=1, figsize=(width,height), zorder=1)
    # Adjust placement inside figure
    # fig.subplots_adjust(left=.1, bottom=0.01, right=.9, top=0.9) 
    # plt.subplots_adjust(wspace=0.4, hspace=0)

    # title_string = outputQuantity + "-" r""+parameterName 
    title_string = "curvature" + "-" r""+parameterName 
    # title_string = ''
    ax1.set_title(title_string,pad=6)


    print('plot curvature over parameter -'+ parameterName)
    print('inputValues:', inputValues)
    print('outputValues_curvature:', outputValues_curvature)

    l1 = ax1.plot(inputValues,outputValues_curvature ,marker='o')

    #Test:tight Layout
    plt.tight_layout()



    fig.set_size_inches(width, height)
    # fig.savefig(resultPath_parent + '/parameterDependence_' + outputQuantity + '_' + parameterName +  '.pdf', dpi=1500) #dpi on
    fig.savefig(resultPath_parent + '/parameterDependence_Curvature' +  '_' + parameterName +  '.pdf', dpi=1500) #dpi on

    #----------------------------------------
    #--- Angle-Plot:
    # Create a figure & axes object
    # fig, ax1 = plt.subplots(ncols=1,nrows=1, figsize=(width,height),gridspec_kw={'hspace': 0.4}, zorder=1)
    fig, ax1 = plt.subplots(ncols=1,nrows=1, figsize=(width,height), zorder=1)
    # Adjust placement inside figure
    # fig.subplots_adjust(left=.1, bottom=0.01, right=.9, top=0.9) 
    # plt.subplots_adjust(wspace=0.4, hspace=0)

    # title_string = outputQuantity + "-" r""+parameterName 
    title_string = "angle" + "-" r""+parameterName 
    # title_string = ''
    ax1.set_title(title_string,pad=6)


    print('plot curvature over parameter -'+ parameterName)
    print('inputValues:', inputValues)
    print('outputValues_angle:', outputValues_angle)

    l1 = ax1.plot(inputValues,outputValues_angle ,marker='o')

    #Test:tight Layout
    plt.tight_layout()



    fig.set_size_inches(width, height)
    # fig.savefig(resultPath_parent + '/parameterDependence_' + outputQuantity + '_' + parameterName +  '.pdf', dpi=1500) #dpi on
    fig.savefig(resultPath_parent + '/parameterDependence_Angle' +  '_' + parameterName +  '.pdf', dpi=1500) #dpi on


#----------------------------------------------------------------------------------------------------------------------
if plotEnergyLandscape_flag:
    print('Plot Energy landscape ...')
    for i in range(0, len(parameterArray)):
        for v in range(0,len(parameterArray[i][1])):
            print("------------------")
            print("New Loop")
            print("------------------")
            print('i:', i)
            print('v:', v)
            print('len(parameterArray[i][1]):', len(parameterArray[i][1]))
            # print('parameterArray[i][v]:', parameterArray[i][v])

            print('parameterName:'  , parameterArray[i][0])
            print('parameterValue: ', parameterArray[i][1][v])

            parameterName =  parameterArray[i][0]
            parameterValue = parameterArray[i][1][v]

            resultPath_parent = resultPathBase + "/" + parameterName
            resultPath = resultPath_parent + "/value_" + str(parameterValue)
            try:
                os.mkdir(resultPath_parent)
            except OSError as error:
                print("")
                # print(error)
            try:
                os.mkdir(resultPath)
            except OSError as error:
                print("")
                # print(error)


            plot_minimizerInOppositeCurvatureRegion = False #this is not necessarily a local minimizer...
            

            # Set Path for effective quantitites.
            QFilePath = resultPath + "/QMatrix.txt"
            BFilePath = resultPath + "/BMatrix.txt"

            # Read the effective quantities from .txt-File
            Q, B = ReadEffectiveQuantities(QFilePath,BFilePath)
            print('Qhom: \n', Q)
            print('Beff: \n', B)
            # Test: symmetrize Qhom
            # Q=0.5*(np.transpose(Q)+Q) # symmetrize


            # N=2000 #Number of Sampling Points
            
            # curvatureLength=2
            
            r, theta = np.meshgrid(np.linspace(0,curvatureLength,N),np.radians(np.linspace(0, 360, N)))

            E = createEnergyValues(r,theta,Q,B)

            """"
                Create the energy landscape from the dataset E.
                If 'Normalize' is set to true the energy is normalized via
                E=E-E.min()
            """
            # title_string = r"ratio $r=0.12$"
            title_string = r""+parameterName + ": " + str(parameterValue)
            title_string = ''
            # createEnergyLandscapeFigure(r,theta,E,curvatureLength,Q,B,resultPath,parameterName,parameterValue,title_string,True)
            # createEnergyLandscapeFigure(r,theta,E,resultPath,parameterName,parameterValue,title_string,True)

            
            createEnergyLandscapeFigure(r,theta,E,resultPath,parameterName,parameterValue,title_string,True,displayMinimizer,plotContourLines)




            #--------------------------------------------------------------------------

            # (Test): eff quantities with x-axial minimizer.
            # B = np.array([1.0, 1.0, 0.0]);

            # Q = np.array([[3.0, 0.5, 0.0],
            #             [0.5, 0.33, 0.0],
            #             [0.0, 0.0, 1.0]]);
            
            # Q = np.array([[1.0, 0.0, 0.0],
            # [0.0, 2.0, 0.0],
            # [0.0, 0.0, 1.0]]);

            # B = np.array([0.0, 0.5, 0.0]);


            # (TEST) y-axial minimizer
            # Q = np.array([[1.0, 0.0, 0.0],
            #             [0.0, 1.0, 0.0],
            #             [0.0, 0.0, 1.0]]);

            # B = np.array([0.0, 5.0, 0.0]);


            # (TEST) pi/4 minimizer (NPG1 - Fig10)
            # Q = np.array([[1.0, 0.0, 0.0],
            #             [0.0, 2.0, 0.0],
            #             [0.0, 0.0, 1.0]]);

            # B = np.array([2.0, 1.5, 0.0]);






            # Compute local and global minimizer (by Sampling method)
            # kappa=0
            # kappa_pos=0
            # kappa_neg=0
            #
            # N=500 #Number of Sampling Points
            # # N=1500
            # # length=5
            # curvatureLength=2
            # r, theta = np.meshgrid(np.linspace(0,curvatureLength,N),np.radians(np.linspace(0, 360, N)))

            # # ----------------------------------------------------
            # # print('r.shape[0]', r.shape[0])
            # # # r, theta = np.meshgrid(np.linspace(0,curvatureLength,N),np.radians(np.linspace(0, 360, N,  endpoint=False)))
            # # E=np.zeros(np.shape(r))
            # # for k in range(0,N): 
            # #     for l in range(0,N):     
            # #         if theta[k,l]<np.pi:
            # #             E[k,l]=energy(r[k,l],theta[k,l],Q,B)
            # #         else:
            # #             E[k,l]=energy(-r[k,l],theta[k,l],Q,B)
            # # ----------------------------------------------------


            # E = createEnergyValues(r,theta,Q,B)

            # # [kappa_globalmin,alpha_globalmin,kappa_localmin,alpha_localmin,energyDifference,minimizer_sign] = getMinimizers(E) 


            # """"
            #     Create the energy landscape from the dataset E.
            #     If 'Normalize' is set to true the energy is normalized via
            #     E=E-E.min()
            # """
            # # title_string = r"ratio $r=0.12$"
            # title_string = r""+parameterName + ": " + str(parameterValue)
            # # createEnergyLandscapeFigure(r,theta,E,title_string,True);
            # # createEnergyLandscapeFigure(r,theta,E,curvatureLength,Q,B,resultPath,parameterName,parameterValue,title_string,True)
            # createEnergyLandscapeFigure(r,theta,E,resultPath,parameterName,parameterValue,title_string,True)




            
            # print('E.argmin():',E.argmin())
            # Compute local and global minimizer (by Sampling method)

            # print('E.shape[0]', E.shape[0])

            # ----------------------------------------------------
            # Compute Minimizer 
            # [kmin,lmin]=np.unravel_index(E.argmin(),(N,N))
            # kappamin=r[kmin,lmin]
            # alphamin=theta[kmin,lmin]

            # Emin = E[kmin,lmin]

            # # Positive curvature region
            # N_mid=int(N/2)
            # [kmin,lmin]=np.unravel_index(E[:N_mid,:].argmin(),(N_mid,N))
            # kappamin_pos=r[kmin,lmin]
            # alphamin_pos=theta[kmin,lmin]
            # Emin_pos=E[kmin,lmin]
            # # Negative curvature region
            # [kmin,lmin]=np.unravel_index(E[N_mid:,:].argmin(),(N_mid,N))
            # kappamin_neg=r[kmin+N_mid,lmin]
            # alphamin_neg=theta[kmin+N_mid,lmin]
            # Emin_neg=E[kmin+N_mid,lmin]
            # #

            # # print('r:', r)
            # # print('theta:', theta)
            # # print('E:', E)


            # print('Emin:', Emin)
            # print('Emin_pos:', Emin_pos)
            # print('Emin_neg:', Emin_neg)

            # print('energy in origin (0,0):' ,energy(0,0,Q,B))

            # if(abs(Emin_pos - Emin_neg)<1e-5):
            #     print('Both minimizers have nearly the same energy - likely two minimizers.')

            # if(Emin_pos < Emin_neg):
            #     print('Global Minimizer has positive curvature.')
            #     minimizer = 'positive'
            #     energyDifference = Emin_neg-Emin_pos
            # else:
            #     print('Global Minimizer has negative curvature.')
            #     minimizer = 'negative'
            #     energyDifference = Emin_pos-Emin_neg

            # print('E.min(): ',E.min())
            # print('E.max(): ',E.max())

            # # Normalize minimum energy to zero:
            # E=E-E.min()


            # print('E.min(): (after normalization): ',E.min())
            # print('E.max(): (after normalization): ',E.max())


            # if (minimizer == 'positive'):
            #     alpha_globalmin = alphamin
            #     kappa_globalmin = kappamin
            #     kappa_localmin = (-1)*kappamin_neg 
            #     alpha_localmin = alphamin_neg
            # else :
            #     alpha_globalmin = alphamin
            #     kappa_globalmin = (-1)*kappamin
            #     kappa_localmin = kappamin_pos
            #     alpha_localmin = alphamin_pos

            # # print('kappamin_pos: ', kappamin_pos)
            # # print('alphamin_pos: ', alphamin_pos)
            # # print('kappamin_neg: ', kappamin_neg)
            # # print('alphamin_neg: ', alphamin_neg)

            # print('kappa_globalmin: ', kappa_globalmin)
            # print('alpha_globalmin: ', alpha_globalmin)
            # print('kappa_localmin: ',  kappa_localmin)
            # print('alpha_localmin: ',  alpha_localmin)


            # #evaluate energy on minimizers
            # # print('energy (kappa_pos)', energy(kappamin_pos,alphamin_pos,Q,B))
            # # print('energy (kappa_neg)', energy(-kappamin_neg,alphamin_neg,Q,B))

            # print('energy (global minimizer)', energy(kappa_globalmin,alpha_globalmin,Q,B))
            # print('energy (local minimizer)', energy(kappa_localmin,alpha_localmin,Q,B))

            # ----------------------------------------------------

#--------------------------------------------------------------------------------------------------------------


        #     # Emax=100
        #     Emax = E.max()
        #     # levs=np.geomspace(1,E.max()*0.5,50)
        #     # levs=np.geomspace(1,Emax,50)
        #     # levs=np.geomspace(0.1,Emax,100)
        #     # print('np.round(E.min(),decimals=2):', np.round(E.min(),decimals=2))
        #     # levs=np.geomspace(0.01,Emax,100)

        #     levs=np.geomspace(0.01,E.max(),300)  # Return numbers spaced evenly on a log scale (a geometric progression).
 
           
        #     # print('levs:', levs)

        #     # levs=np.geomspace(E.min(),E.max(),400)  #(np.geomspace: Return numbers spaced evenly on a log scale) 
        #     # levs=np.geomspace(0,E.max(),400)
        #     # levs=np.geomspace(1,Emax,400)

        #     ## Create Figure
        #     # fig, (ax1) = plt.subplots( nrows=1,figsize=(3,3.5),subplot_kw=dict(projection='polar'), gridspec_kw={'hspace': 0.4})

        #     # fig, ax1 = plt.subplots( figsize=(width,height),subplot_kw=dict(projection='polar'), gridspec_kw={'hspace': 0.4})
        #     # fig, ax1 = plt.subplots(ncols=1,nrows=1, figsize=(width,height),subplot_kw=dict(projection='polar'))
        #     fig, ax1 = plt.subplots(ncols=1,nrows=1, figsize=(width,height), subplot_kw=dict(polar=True),gridspec_kw={'hspace': 0.4}, zorder=1)
        #     fig.subplots_adjust(left=.1, bottom=0.01, right=.9, top=0.9)  #adjust placement inside figure

        #     # pcm=ax1.contourf(theta, r, E, levs, norm=colors.PowerNorm(gamma=0.75), cmap='brg', zorder=0)
        #     # pcm=ax1.contourf(theta, r, E,100 , norm=colors.PowerNorm(gamma=0.4), cmap='brg', zorder=0)
        #     # pcm=ax1.contourf(theta, r, E, levs, norm=colors.PowerNorm(gamma=1.0), cmap='brg', zorder=0)
        #     # pcm=ax1.contourf(theta, r, E, levs, norm=colors.PowerNorm(gamma=0.5), cmap='brg', zorder=0)
        #     # pcm=ax1.contourf(theta, r, E, levs, norm=colors.PowerNorm(gamma=0.4,vmin=E.mins(),vmax=E.max()), cmap='brg', zorder=0)


            
        #     """
        #         ---Test: Define new custom colormap
        #         define top and bottom colormaps 
        #     """
        #     top = cm.get_cmap('Oranges_r', 128) # r means reversed version
        #     bottom = cm.get_cmap('Blues', 128)# combine it all
        #     newcolors = np.vstack((top(np.linspace(0, 1, 128)),
        #                         bottom(np.linspace(0, 1, 128))))# create a new colormaps with a name of OrangeBlue
        #     orange_blue = colors.ListedColormap(newcolors, name='OrangeBlue')


        #     # bi_pride = LinearSegmentedColormap.from_list("", ["#D60270", "#9B4F96", "#0038A8"])
        #     # testColor = LinearSegmentedColormap.from_list("", ["#4B0082",  "#FF7F50"])
        #     testColor = LinearSegmentedColormap.from_list("", ["#380282","#0343DF","#FF7F50",  "#FE420F"])

        #     """
        #         Plot with Contourf:
        #     """
        #     # pcm=ax1.contourf(theta, r, E, levs, norm=colors.PowerNorm(gamma=0.5,vmin=E.min(),vmax=E.max()), cmap='brg', zorder=0)
        #     # # # # # pcm=ax1.contourf(theta, r, E, levs, norm=colors.PowerNorm(gamma=0.4,vmin=E.min(),vmax=E.max()), cmap=mpl.cm.magma, zorder=0)
        #     # # # # ###--- Hide Contour LineStroke (remove white lines between contour levels)
        #     # for c in pcm.collections:
        #     #   c.set_edgecolor("face")
        #     # pcm.collections.set_edgecolor("face")

        #     #Test imshow
        #     # pcm=ax1.imshow(E,extent=[r.min(), r.max(), np.degrees(theta.min()),np.degrees(theta.max())],  norm=colors.PowerNorm(gamma=0.4,vmin=E.min(),vmax=E.max()), cmap=mpl.cm.magma, origin='lower')

        #     ### 
        #     """
        #         Test Pcolormesh
        #         * Reducing the image-quality/file-size by using rasterized option:
        #         * Looks much smoother without 'rasterize' option however file-size gets out of hand..: 
        #         * Together with the 'dpi=..' option of figsave we can control the file-size
        #         * Advantage: Text etc. is still vectorized without having too large files.

        #         Problem: How to get the Colorbarticks right (uniform spacing) when using PowerNorm (unclear)
        #     """
        #     pcm=ax1.pcolormesh(theta, r, E, norm=colors.PowerNorm(gamma=0.4,vmin=E.min(),vmax=E.max()) ,cmap='plasma', edgecolors='face', zorder=0, rasterized=True, alpha=0.8) 

        #     # pcm=ax1.pcolormesh(theta, r, E, norm=colors.PowerNorm(gamma=0.4,vmin=E.min(),vmax=E.max()) ,cmap=testColor, edgecolors='face', zorder=0, rasterized=True, alpha=0.7) 
        #     # pcm=ax1.pcolormesh(theta, r, E, norm=colors.PowerNorm(gamma=0.2,vmin=E.min(),vmax=E.max()) ,cmap='gray', edgecolors='face', zorder=0, rasterized=True, alpha=0.8) 
        #     # pcm=ax1.pcolormesh(theta, r, E, norm=colors.PowerNorm(gamma=0.5,vmin=E.min(),vmax=E.max()) ,cmap=orange_blue, edgecolors='face', zorder=0, rasterized=True, alpha=0.8) 


        #     # colormaptest=mpl.cm.get_cmap('viridis')
        #     # colormaptest.set_under("k")

        #     # pcm=ax1.pcolormesh(theta, r, E, norm=colors.PowerNorm(gamma=0.4,vmin=E.min(),vmax=E.max()) ,cmap=colormaptest, edgecolors='face', zorder=0, rasterized=True, shading='auto') 


        #     #--Test Approach from : https://stackoverflow.com/questions/61897393/unevenly-irregularly-spaced-data-for-colorbar-with-evenly-spaced-colors
        #     # energyRange=np.linspace(E.min(),E.max(),10)
        #     # cmap_vir = plt.get_cmap('viridis')
        #     # colors = cmap_vir(np.linspace(0, 1, len(energyRange) - 1))
        #     # cmap, norm = mpl.colors.from_levels_and_colors(energyRange, colors)
        #     # pcm=ax1.pcolormesh(theta, r, E, cmap=cmap, norm=norm, rasterized=True) 


        #     # ColorNorm = colors.PowerNorm(gamma=0.4,vmin=E.min(),vmax=E.max())

            
        #     # pcm=ax1.pcolormesh(theta, r, E, norm=colors.PowerNorm(gamma=0.4,vmin=E.min(),vmax=E.max()), cmap='viridis', edgecolors='face')
        #     # pcm=ax1.pcolormesh(theta, r, E, norm=ColorNorm ,cmap='brg', edgecolors='face', zorder=0, rasterized=True, shading='auto') 

        #     # mpl.rcParams.update({"axes.grid" : False}) # Add grid

        #     # pcm=ax1.pcolormesh(theta, r, E, norm=ColorNorm ,cmap='brg', edgecolors='face', zorder=0, rasterized=True) 
        #     #Test tricontour:
        #     # pcm=ax1.tricontourf(theta, r, E)

        #     # print('ColorNorm:', ColorNorm)
        #     # print('ColorNorm(E.min()):',ColorNorm(E.min()))
        #     # print('ColorNorm(E.max()/2.0):',ColorNorm(E.max()/2.0))
        #     # print('ColorNorm(E.max()):',ColorNorm(E.max()))


        #     print('0.025*E.max():',0.025*E.max())
        #     print('energyDifference: ', energyDifference)
        #     ### Create additional contour-line plot:
        #     contour_levs=np.geomspace(0.01,E.max(),1)  # levels used for an additional contour-plot
        #     contour_levs = [0.1]
        #     # contour_levs = np.linspace(0.001,0.5,4)
        #     # contour_levs = np.linspace(0.001,0.25*E.max(),10)
        #     # contour_levs = np.linspace(0.001,energyDifference*1.0,10) # contour only from zero (Minimizer) to energyDifference between global/local Minimizer.

        #     # contour_levs_minimizer = np.linspace(0.001,energyDifference*0.5,6)
        #     # contour_levs = np.linspace(0.0001,energyDifference*0.75,6) # contour only from zero (Minimizer) to energyDifference between global/local Minimizer.
        #     contour_levs = np.linspace(0.0001,energyDifference*1.0,6) # contour only from zero (Minimizer) to energyDifference between global/local Minimizer.
        #     print('contour_levs:', contour_levs)
        #     contours = plt.contour(theta, r, E, contour_levs, norm=colors.PowerNorm(gamma=0.4,vmin=E.min(),vmax=E.max()), colors='ivory',linewidths=0.65, linestyles="dashed", alpha=0.8, zorder=2)
        #     contours_min = plt.contour(theta, r, E, [contour_levs[1]], norm=colors.PowerNorm(gamma=0.4,vmin=E.min(),vmax=E.max()), colors='yellow',linewidths=0.65, linestyles="solid", alpha=0.9, zorder=2)
        #     # contours = plt.contour(theta, r, E, contour_levs, norm=colors.PowerNorm(gamma=0.4,vmin=E.min(),vmax=E.max()), ,linewidths=0.1, linestyles="dashdot")
        #     # contours = plt.contour(theta, r, E, contour_levs, norm=colors.PowerNorm(gamma=0.4,vmin=E.min(),vmax=E.max()), cmap='plasma',linewidths=0.1, linestyles="dashdot")
        #     # ax1.clabel(contours, inline=True, fontsize=4)
        #     # contours = plt.contour(theta, r, E, contour_levs, norm=colors.PowerNorm(gamma=0.4,vmin=E.min(),vmax=E.max()), colors='black',linewidths=0.1, linestyles="dashed")
        #     # contours = plt.contour(theta, r, E, levs,norm=colors.PowerNorm(gamma=0.4,vmin=E.min(),vmax=E.max()), linewidths=0.1, linestyles="dashed", locator=mpl.ticker.LogLocator())
        #     # plt.clabel(contours, inline=True, fontsize=4)

            
        #     # pcm=ax1.contourf(theta, r, E, levs, norm=colors.PowerNorm(gamma=0.4,vmin=E.min(),vmax=E.max()), cmap='terrain', zorder=0)
        #     # pcm=ax1.contourf(theta, r, E, levs, norm=colors.PowerNorm(gamma=0.5,vmin=E.min(),vmax=E.max()), cmap=plt.cm.bone, zorder=0)


        #     ###--- Set Title
        #     ax1.set_title(r"ratio $r=0.12$",pad=6)
        #     # ax1.set_title(r"ratio $r=0.12$",pad=10)
        #     # ax1.set_title(r""+parameterName + ": " + str(parameterValue),pad=20)






            

        #     # # Plot global minimizer
        #     # ax1.plot(alpha_globalmin, abs(kappa_globalmin),
        #     #             markerfacecolor='blue',
        #     #             markeredgecolor='white',            # marker edgecolor
        #     #             marker='s',                         # each marker will be rendered as a circle
        #     #             markersize=4,                       # marker size
        #     #             markeredgewidth=0.5,                  # marker edge width
        #     #             linewidth=0,
        #     #             zorder=3,
        #     #             alpha=1,                           # Change opacity
        #     #             label = r"$\kappa_{0^\circ}(m^{-1})$")        
        #     # Plot global minimizer


        #     Minimizer_string = ': ('+ str(np.round(np.rad2deg(alpha_globalmin),decimals=1)) + '°' + ',' + str(np.round(abs(kappa_globalmin),decimals=2))+ ')'


        #     # Mark Global Minimizer with a dot.
        #     gmin = ax1.plot(alpha_globalmin, abs(kappa_globalmin),
        #                     markerfacecolor='cornflowerblue',
        #                     markeredgecolor='white',            # marker edgecolor
        #                     marker='o',                         # each marker will be rendered as a circle
        #                     markersize=6,                       # marker size
        #                     markeredgewidth=1.0,                  # marker edge width
        #                     linewidth=0,
        #                     zorder=3,
        #                     alpha=1,                           # Change opacity
        #                     label = Minimizer_string)   
        #                     # label = r"$\kappa_{0^\circ}(m^{-1})$")      
                

        #     # # #TEST: For Annotation
        #     # ax1.plot(np.deg2rad(290), curvatureLength+1,
        #     #             markerfacecolor='cornflowerblue',
        #     #             markeredgecolor='white',            # marker edgecolor
        #     #             marker='o',                         # each marker will be rendered as a circle
        #     #             markersize=6,                       # marker size
        #     #             markeredgewidth=1.0,                  # marker edge width
        #     #             linewidth=0,
        #     #             zorder=3,
        #     #             alpha=1                           # Change opacity      
        #     #             )
            
        #     if (minimizer_sign == 'positive'):
        #         horizontal_annotation_alignment = 'left'
        #         # kappa_sign_string = ""
        #     else : 
        #         horizontal_annotation_alignment = 'right'
        #         # kappa_sign_string = "-"
        #     #--- annotate global minimizer
            
        #     # ax1.annotate( '('+ str(np.round(np.rad2deg(alpha_globalmin),decimals=1)) + '°' + ',' + str(np.round(abs(kappa_globalmin),decimals=2))+ ')' ,
        #     # # ax1.annotate( r'$(\theta_{m}, \kappa_m)=$' + '('+ str(np.round(np.rad2deg(alphamin),decimals=1)) + '°' + ',' + str(np.round(kappamin,decimals=1))+ ')' ,
        #     #             # xycoords='polar',
        #     #             # xy = (alpha_globalmin-0.15,abs(kappa_globalmin)+0.25),
        #     #             # xy = (alpha_globalmin-0.10,abs(kappa_globalmin)+0.1),
        #     #             xy = (alpha_globalmin,abs(kappa_globalmin)),
        #     #             # xytext=(0.10, np.round(kappa_globalmin,decimals=2)-0.25),
        #     #             # textcoords='polar',
        #     #             # textcoords='offset points',
        #     #             # xytext = (alpha_globalmin-0.10,abs(kappa_globalmin)+0.1),
        #     #             # textcoords='figure fraction',
        #     #             xycoords=ax1.get_xaxis_transform(),
        #     #             # xytext = (0.5,0.5),
        #     #             # xytext=(alpha_globalmin-0.25,abs(kappa_globalmin)+0.15), #Position of Text-annotation
        #     #             # rotation=np.rad2deg(alpha_globalmin),
        #     #             horizontalalignment=horizontal_annotation_alignment, 
        #     #             verticalalignment="bottom",
        #     #             color='ivory',
        #     #             zorder=4,
        #     #             fontsize='9')
            


            
        #     if plot_minimizerInOppositeCurvatureRegion:
        #             # Plot local minimizer
        #             # ax1.plot(alphamin_neg, kappamin_neg,
        #             ax1.plot(alpha_localmin, abs(kappa_localmin),   # We need to take abs(kappa) since negative curvatures are still plotted with a positive kappa!
        #                         markerfacecolor='green',    
        #                         markeredgecolor='white',            # marker edgecolor
        #                         marker='D',                         # each marker will be rendered as a circle
        #                         markersize=4,                       # marker size
        #                         markeredgewidth=0.5,                  # marker edge width
        #                         linewidth=0,                      # line width
        #                         zorder=3,
        #                         alpha=1)
                    

        #             #--- annotate local minimizer
        #             ax1.annotate( '('+ str(np.round(360-np.rad2deg(alpha_localmin),decimals=1)) + '°' + ',' + str(np.round(kappa_localmin,decimals=2))+ ')' ,
        #                         xy = (alpha_localmin,abs(kappa_localmin)),
        #                         # xytext=(-1.6, np.round(kappa_localmin,decimals=2)+0.9),
        #                         # xytext=(-1.6, np.round(kappa_localmin,decimals=2)),
        #                         xytext=(alpha_localmin,abs(kappa_localmin)),
        #                         color='ivory',
        #                         # zorder=5,
        #                         fontsize='8')


        #     # print('alphamin: ' , alphamin ) 
        #     # print('kappamin: ' , kappamin ) 
        #     # print('Global Minimizer (alphamin, kappamin):' , '('+ str(np.round(np.rad2deg(alphamin),decimals=1)) + ',' + str(np.round(kappamin,decimals=1))+ ')' ) 
        #     print('Global Minimizer (alphamin, kappamin):' , '('+ str(np.round(np.rad2deg(alpha_globalmin),decimals=1)) + ',' + str(np.round(abs(kappa_globalmin),decimals=2))+ ')' ) 
        #     # print('Local Minimizer (alphamin, kappamin):' , '('+ str(np.round(360-np.rad2deg(alphamin_neg),decimals=1)) + ',' + str(np.round(-kappamin_neg,decimals=1))+ ')' ) 


        #     print('Local Minimizer opposite curvature (alphamin, kappamin):' , '('+ str(np.round(360-np.rad2deg(alpha_localmin),decimals=1)) + ',' + str(np.round(abs(kappa_localmin),decimals=2))+ ')' ) 
        #     # ax1.annotate(alphamin, (alphamin,kappamin))




        #     # rotate radius axis labels.
        #     # ax1.set_rlabel_position(135)

        #     colorbarticks=np.geomspace(0.00001,E.max(),10)
        #     # # colorbarticks=np.geomspace(0.00001,Emax,4)
        #     # colorbarticks=np.linspace(E.min(),E.max(),10)
        #     # # colorbarticks=np.geomspace(0.00001,E.max(),14)

        #     # linSeq = np.linspace(E.min(),E.max(),10)
        #     # linSeq = np.geomspace(0.00001,Emax,10)

        #     # colorbarticks = ColorNorm.inverse(((linSeq - E.min())/(E.max()-E.min()))**0.4)


        #     # colorbarticks=ColorNorm(np.linspace(E.min(),E.max(),4)) * E.max()



        #     #TEST: evenly sample values from E:
        #     # numElems = 3
        #     # idx = np.round(np.linspace(0, len(E) - 1, numElems)).astype(int)
        #     # colorbarticks = E[0][idx]
        #     print('colorbarticks:', colorbarticks)



        #     # We need to map those colorbarticks to the colorbar.

        #     #---Test
        #     # axins = inset_axes( ax1,
        #     #                     width="100%",  
        #     #                     height="5%",
        #     #                     loc='lower center',
        #     #                     borderpad=-5
        #     #                    )
            

        #     #-------------------


        #     # cbar = fig.colorbar(pcm,ticks=energyRange)


        #     # Colorbar for Contourf-Plot:
        #     # cbar = plt.colorbar(pcm, ax=[ax1], extend='max', ticks=colorbarticks, pad=0.1, orientation="horizontal")

        #     # Colorbar for pcolormesh-Plot:
        #     # cbar = fig.colorbar(pcm, ax=ax1, pad=0.075,  orientation="horizontal") # so far best with pcolormesh.
        #     cbar = fig.colorbar(pcm, ax=ax1, pad=0.1,  orientation="horizontal") # so far best with pcolormesh.

        #     # cbar = plt.colorbar(pcm, ax=[ax1], extend='max', pad=0.1, orientation="horizontal")

        #     # cbar = plt.colorbar(pcm, ax=[ax1], norm=colors.PowerNorm(gamma=0.4,vmin=E.min(),vmax=E.max()), extend='max', ticks=colorbarticks, pad=0.1, orientation="horizontal")
        #     # fig.colorbar(pcm, ax=ax1, pad=0.1, norm=colors.PowerNorm(gamma=0.4,vmin=E.min(),vmax=E.max()), ticks=colorbarticks,  orientation="horizontal")
        #     # cbar = plt.colorbar(pcm, ax=[ax1], extend='max', pad=0.2, orientation="horizontal")
        #     # cbar = plt.colorbar(pcm, ax=[ax1], extend='max',norm=colors.PowerNorm(gamma=0.4,vmin=E.min(),vmax=E.max()), ticks=colorbarticks, pad=0.2, orientation="horizontal")
        #     # fig.colorbar(pcm, ax=ax1, pad=0.1, ticks=colorbarticks,  orientation="horizontal", spacing='proportional')

        #     # fig.colorbar(pcm, ax=ax1, pad=0.1,  orientation="horizontal", spacing='proportional')




        #     # cbar = fig.colorbar(pcm, ax=ax1, norm=colors.PowerNorm(gamma=0.4,vmin=E.min(),vmax=E.max()),ticks=colorbarticks, pad=0.1,  orientation="horizontal")
        #     # cbar.ax.set_xscale('linear') 
        #     # cbar.ax.set_xscale('log') 

        #     # cbar = mpl.colorbar.ColorbarBase()

        #     # fig.colorbar(pcm, ax=[ax1], extend='max', ticks=colorbarticks, pad=0.1, orientation="horizontal", cax=axins)
        #     # cbar = plt.colorbar(pcm, ax=[ax1], ticks=colorbarticks, pad=0.2, orientation="horizontal", location = 'bottom', fraction=0.1)
        #     # cbar.ax.tick_params(labelsize=8)

        #     """
        #         Set Tick labels
        #         x: Angle 
        #         y: Radius
            
        #     """

        #     # plt.rcParams["axes.axisbelow"] = False

        #     anglelabel=["0°","45°", "90°", "135°", "180°","-135°","-90°","-45°"]
        #     # anglelabel=["0°","45°", "90°", "135°",r"$\pm180$° ","-135°","-90°","-45°"]
        #     ax1.set_xticks(np.array([.0,1/4,2/4,3/4,1,5/4,6/4,7/4])*np.pi)
        #     # ax1.set_xticks(np.pi/180. * np.linspace(180,  -180, 8, endpoint=False))
        #     ax1.set_xticklabels(anglelabel)
        #     # ax1.xaxis.grid(True, color='white')
        #     ax1.xaxis.grid(True)
        #     # ax1.zorder=4
        #     # ax1.set_zorder(ax1.get_zorder()+4); 
        #     # ax1.grid(zorder=10)
        #     # ax1.patch.set_visible(False)

        #     # We want to grid-axis to be on top of the contour lines to hide confusing contours on the grid-axis.
        #     ax1.set_axisbelow(False)

        #     # tick locations
        #     # thetaticks = np.arange(0,360,45)
        #     # # set ticklabels location at 1.3 times the axes' radius
        #     # ax1.set_thetagrids(thetaticks, frac=1.3)

        #     # Adjust pad of xticklabels:
        #     ax1.tick_params(pad=0.5)

        #     #rotate radius axis labels.
        #     # ax1.set_rlabel_position(135)
        #     ax1.set_rlabel_position(225)
        #     # ax1.set_rlabel_position(235)

        #     # ax1.set_rticks([0.5, 1, 1.5, 2])  # Less radial ticks

            


        #     # ax1.axis.set_major_locator(MultipleLocator(0.5))
        #     # ax1.yaxis.set_major_locator(MultipleLocator(0.5))

        #     radiusTickLength = 0.5
        #     ax1.yaxis.set_major_locator(plt.FixedLocator(np.arange(radiusTickLength,curvatureLength,radiusTickLength)))

        #     # ax1.set_yticks(np.array([1,2,3,4]))
        #     # ax1.set_yticklabels(["1","2","3","4"], zorder=20, color="white")
        #     # ax1.yxis.set_major_locator
        #     # ax1.set_yticks(np.array([1,2]))
        #     # ax1.set_yticklabels(["1","2"], zorder=20, color="white")
        #     # ax1.set_yticks(np.array([1,1.5]))
        #     # ax1.set_yticklabels(["1","1.5"], zorder=20, color="white")
        #     # ax1.set_yticks(np.array([1,2,3]))
        #     # ax1.set_yticklabels(["1","2","3"], zorder=20, color="white")
        #     ax1.yaxis.set_tick_params(color='white', pad = 1.0)
        #     # ax1.yaxis.grid(True, color='white', alpha=0.75)
        #     ax1.yaxis.grid(True)

        #     # ax1.spines['polar'].set_visible(True)
        #     # Create Minor ticks manually as polar coordinates does not have the option.
        #     tick = [ax1.get_rmax(),ax1.get_rmax()*0.97]
        #     for t  in np.deg2rad(np.arange(0,360,5)):
        #         ax1.plot([t,t], tick, lw=0.1, color="k")


        #     #Test:tight Layout
        #     # plt.tight_layout()


        #     #TEST: Legend
        #     # ax1.legend(loc="lower center")
        #     # ax1.legend(loc="lower right",bbox_to_anchor=[1.0, 0.01],frameon=True)

        #     # ax1.legend(bbox_to_anchor=[0.8, -0.05],loc='center',borderaxespad=0.1,frameon=True)
        #     # ax1.legend(bbox_to_anchor=[0.8, -0.1],loc='lower center',borderaxespad=0.1,frameon=True)
        #     # ax1.legend(bbox_to_anchor=[0.8, 0.2],borderaxespad=0.1,frameon=True,bbox_transform=fig.transFigure)
        #     # ax1.legend(loc='best')
        #     legend = ax1.legend(bbox_to_anchor=[0.75, 0.15],loc='lower center',borderaxespad=0.1,frameon=True,bbox_transform=fig.transFigure,handletextpad=0.1)
        #     frame = legend.get_frame()
        #     # frame.set_color('white')
        #     frame.set_edgecolor('black')



        #     # axbox = ax1.get_position()
        #     # legend = fig.legend([gmin], [Minimizer_string], loc='center',bbox_to_anchor=[axbox.x0+0.5*axbox.width, axbox.y0-0.05], bbox_transform=fig.transFigure)
        #     # fig.legend(gmin, r""+Minimizer_string)
        # #    labels=line_labels,   # The labels for each line
        # #    loc="center right",   # Position of legend
        # #    bbox_to_anchor=[1.35, 0.55],
        # #    borderaxespad=0.15,    # Small spacing around legend box
        # #    frameon=True
        # #    # title="Legend Title"  # Title for the legend
        # #    )

        #     # Save Figure as png.
        #     # fig.savefig(resultPath + '/energy_landscape_'+ parameterName + '_' +str(parameterValue) + '.png', dpi=100)
        #     # Save Figure as pdf.
        #     fig.set_size_inches(width, height)
        #     fig.savefig(resultPath + '/energy_landscape_'+ parameterName + '_' +str(parameterValue) + '.pdf', dpi=500) #dpi only has an effect if "rasterize" option is used.
        #     # fig.savefig(resultPath + '/energy_landscape_'+ parameterName + '_' +str(parameterValue) + 'noDPI' + '.pdf')


        #     #Plot Colorbar separately:



        #     # fig.savefig(resultPath + '/energy_landscape_'+ parameterName + '_' +str(parameterValue) + 'Legend' + '.pdf',
        #     #              dpi=300,
        #     #              bbox_inches='tight')

# --------------------------------------------------------------------------------------------------------------





# OLD VERSION:
# plt.style.use("seaborn")
# plt.style.use('paperstyle.mplstyle')


# # plt.style.use("seaborn")

# # mpl.rcParams['text.usetex'] = True
# # mpl.rcParams["font.family"] = "serif"
# # mpl.rcParams["font.size"] = "8"
# # mpl.rcParams['xtick.bottom'] = True
# # mpl.rcParams['xtick.major.size'] = 2
# # mpl.rcParams['xtick.minor.size'] = 1.5
# # mpl.rcParams['xtick.major.width'] = 0.75
# # # mpl.rcParams['xtick.labelsize'] = 8
# # mpl.rcParams['xtick.major.pad'] = 1
# # mpl.rcParams['ytick.left'] = True
# # mpl.rcParams['ytick.major.size'] = 2
# # mpl.rcParams['ytick.minor.size'] = 1.5
# # mpl.rcParams['ytick.major.width'] = 0.75
# # mpl.rcParams['ytick.labelsize'] = 8
# # mpl.rcParams['ytick.major.pad'] = 1
# # mpl.rcParams['axes.titlesize'] = 8
# # mpl.rcParams['axes.titlepad'] = 1
# # # mpl.rcParams['axes.labelsize'] = 8
# # #Adjust Legend:
# # mpl.rcParams['legend.frameon'] = True       # Use frame for legend
# # # mpl.rcParams['legend.framealpha'] = 0.5 
# # mpl.rcParams['legend.fontsize'] = 8         # fontsize of legend
# # #Adjust grid:
# # # mpl.rcParams.update({"axes.grid" : True}) # Add grid
# # mpl.rcParams.update({"axes.grid" : False}) # Add grid
# # mpl.rcParams['axes.labelpad'] = 3
# # mpl.rcParams['grid.linewidth'] = 0.25
# # mpl.rcParams['grid.alpha'] = 0.75 # 0.75
# # mpl.rcParams['grid.linestyle'] = '-'
# # mpl.rcParams['grid.color']   = 'lightgray'#'black'
# # mpl.rcParams['text.latex.preamble'] = r'\usepackage{amsfonts}' # Makes Use of \mathbb possible.



# textwidth = 6.26894 #textwidth in inch
# # width = textwidth * 0.5
# width = textwidth * 0.33
# # width = textwidth 
# height = width/1.618 # The golden ratio.


#             # Emax=100
#             Emax = E.max()
#             # levs=np.geomspace(1,E.max()*0.5,50)
#             # levs=np.geomspace(1,Emax,50)
#             # levs=np.geomspace(0.1,Emax,100)
#             # print('np.round(E.min(),decimals=2):', np.round(E.min(),decimals=2))
#             # levs=np.geomspace(0.01,Emax,100)
#             levs=np.geomspace(0.01,Emax,200)
#             # print('levs:', levs)

#             # levs=np.geomspace(E.min(),E.max(),400)  #(np.geomspace: Return numbers spaced evenly on a log scale) 
#             # levs=np.geomspace(0,E.max(),400)
#             # levs=np.geomspace(1,Emax,400)

#             ## Create Figure
#             # fig, (ax1) = plt.subplots( nrows=1,figsize=(3,3.5),subplot_kw=dict(projection='polar'), gridspec_kw={'hspace': 0.4})

#             # fig, ax1 = plt.subplots( figsize=(width,height),subplot_kw=dict(projection='polar'), gridspec_kw={'hspace': 0.4})
#             fig, ax1 = plt.subplots(ncols=1,nrows=1, figsize=(width,height),subplot_kw=dict(projection='polar'))
#             fig.subplots_adjust(left=.1, bottom=.1, right=.95, top=.95)  #adjust placement inside figure

#             # pcm=ax1.contourf(theta, r, E, levs, norm=colors.PowerNorm(gamma=0.75), cmap='brg', zorder=0)
#             # pcm=ax1.contourf(theta, r, E,100 , norm=colors.PowerNorm(gamma=0.4), cmap='brg', zorder=0)
#             # pcm=ax1.contourf(theta, r, E, levs, norm=colors.PowerNorm(gamma=1.0), cmap='brg', zorder=0)
#             # pcm=ax1.contourf(theta, r, E, levs, norm=colors.PowerNorm(gamma=0.5), cmap='brg', zorder=0)
#             pcm=ax1.contourf(theta, r, E, levs, norm=colors.PowerNorm(gamma=0.4,vmin=E.min(),vmax=E.max()), cmap='brg', zorder=0)
#             # pcm=ax1.contourf(theta, r, E, levs, norm=colors.PowerNorm(gamma=0.4,vmin=E.min(),vmax=E.max()), cmap='terrain', zorder=0)
#             # pcm=ax1.contourf(theta, r, E, levs, norm=colors.PowerNorm(gamma=0.5,vmin=E.min(),vmax=E.max()), cmap=plt.cm.bone, zorder=0)


#             ###--- Set Title
#             # ax1.set_title(r"ratio $r=0.12$",pad=20)
#             # ax1.set_title(r""+parameterName + ": " + str(parameterValue),pad=20)






            

#             # Plot global minimizer
#             ax1.plot(alpha_globalmin, abs(kappa_globalmin),
#                         markerfacecolor='blue',
#                         markeredgecolor='white',            # marker edgecolor
#                         marker='s',                         # each marker will be rendered as a circle
#                         markersize=6,                       # marker size
#                         markeredgewidth=1,                  # marker edge width
#                         linewidth=0,
#                         zorder=3,
#                         alpha=1,                           # Change opacity
#                         label = r"$\kappa_{0^\circ}(m^{-1})$")        
            
#             if (minimizer == 'positive'):
#                 horizontal_annotation_alignment = 'left'
#                 # kappa_sign_string = ""
#             else : 
#                 horizontal_annotation_alignment = 'right'
#                 # kappa_sign_string = "-"
#             #--- annotate global minimizer
            
#             ax1.annotate( '('+ str(np.round(np.rad2deg(alpha_globalmin),decimals=1)) + '°' + ',' + str(np.round(kappa_globalmin,decimals=2))+ ')' ,
#             # ax1.annotate( r'$(\theta_{m}, \kappa_m)=$' + '('+ str(np.round(np.rad2deg(alphamin),decimals=1)) + '°' + ',' + str(np.round(kappamin,decimals=1))+ ')' ,
#                         # xycoords='polar',
#                         # xy = (alpha_globalmin-0.15,abs(kappa_globalmin)+0.25),
#                         xy = (alpha_globalmin-0.10,abs(kappa_globalmin)+0.1),
#                         # xytext=(0.10, np.round(kappa_globalmin,decimals=2)-0.25),
#                         # textcoords='figure fraction',
#                         # xytext = (0.5,0.5),
#                         # xytext=(alpha_globalmin-0.25,abs(kappa_globalmin)+0.15), #Position of Text-annotation
#                         # rotation=np.rad2deg(alpha_globalmin),
#                         ha=horizontal_annotation_alignment, va="bottom",
#                         color='ivory',
#                         zorder=4,
#                         fontsize='8')
            


            
#             if plot_minimizerInOppositeCurvatureRegion:
#                     # Plot local minimizer
#                     # ax1.plot(alphamin_neg, kappamin_neg,
#                     ax1.plot(alpha_localmin, abs(kappa_localmin),   # We need to take abs(kappa) since negative curvatures are still plotted with a positive kappa!
#                                 markerfacecolor='green',    
#                                 markeredgecolor='white',            # marker edgecolor
#                                 marker='D',                         # each marker will be rendered as a circle
#                                 markersize=6,                       # marker size
#                                 markeredgewidth=1,                  # marker edge width
#                                 linewidth=0,                      # line width
#                                 zorder=3,
#                                 alpha=1)
                    

#                     #--- annotate local minimizer
#                     ax1.annotate( '('+ str(np.round(360-np.rad2deg(alpha_localmin),decimals=1)) + '°' + ',' + str(np.round(kappa_localmin,decimals=2))+ ')' ,
#                                 xy = (alpha_localmin,abs(kappa_localmin)),
#                                 # xytext=(-1.6, np.round(kappa_localmin,decimals=2)+0.9),
#                                 # xytext=(-1.6, np.round(kappa_localmin,decimals=2)),
#                                 xytext=(alpha_localmin,abs(kappa_localmin)),
#                                 color='ivory',
#                                 # zorder=5,
#                                 fontsize='8')


#             # print('alphamin: ' , alphamin ) 
#             # print('kappamin: ' , kappamin ) 
#             # print('Global Minimizer (alphamin, kappamin):' , '('+ str(np.round(np.rad2deg(alphamin),decimals=1)) + ',' + str(np.round(kappamin,decimals=1))+ ')' ) 
#             print('Global Minimizer (alphamin, kappamin):' , '('+ str(np.round(np.rad2deg(alpha_globalmin),decimals=1)) + ',' + str(np.round(abs(kappa_globalmin),decimals=2))+ ')' ) 
#             # print('Local Minimizer (alphamin, kappamin):' , '('+ str(np.round(360-np.rad2deg(alphamin_neg),decimals=1)) + ',' + str(np.round(-kappamin_neg,decimals=1))+ ')' ) 


#             print('Local Minimizer opposite curvature (alphamin, kappamin):' , '('+ str(np.round(360-np.rad2deg(alpha_localmin),decimals=1)) + ',' + str(np.round(abs(kappa_localmin),decimals=2))+ ')' ) 
#             # ax1.annotate(alphamin, (alphamin,kappamin))




#             # rotate radius axis labels.
#             # ax1.set_rlabel_position(135)

#             colorbarticks=np.geomspace(0.00001,Emax,10)


            
#             cbar = plt.colorbar(pcm, ax=[ax1], extend='max', ticks=colorbarticks, pad=0.1, orientation="horizontal")
#             cbar.ax.tick_params(labelsize=8)

#             anglelabel=["0°","45°", "90°", "135°","180°","135°","90°","45°"]
#             ax1.set_xticks(np.array([.0,1/4,2/4,3/4,1,5/4,6/4,7/4])*np.pi)
#             ax1.set_xticklabels(anglelabel)
#             ax1.xaxis.grid(True, color='white')
#             # ax1.set_yticks(np.array([1,2,3,4]))
#             # ax1.set_yticklabels(["1","2","3","4"], zorder=20, color="white")
#             ax1.set_yticks(np.array([1,2,3]))
#             ax1.set_yticklabels(["1","2","3"], zorder=20, color="white")
#             ax1.yaxis.set_tick_params(color='white')
#             ax1.yaxis.grid(True, color='white', alpha=0.75)
#             # Save Figure as pdf.
#             fig.savefig(resultPath + '/energy_landscape_'+ parameterName + '_' +str(parameterValue) + '.png', dpi=100)

#             fig.set_size_inches(width, height)
#             fig.savefig(resultPath + '/energy_landscape_'+ parameterName + '_' +str(parameterValue) + '.pdf')

