# In order to run the simulations, an installation of docker is required (see https://docs.docker.com/engine/install/ ).
# The simulations as well as the creation of figures is done in the following steps:

@RUN THE SIMULATIONS

# 1.  Build the docker Container image (named 'woodsim_image') from 'Containerfile':

docker build --no-cache=true -t woodsim_image -f Containerfile .

# 2.  Start the computation of Correctors and effective quantities.
# create container woodsim_container from the image 'woodsim_image' and run the command 'python3 ...'
# *input arguments: 1: Container-Flag(True if script is used inside container) 2: first experiment number 3: last experiment number.
# e.g. "1 0 3" ~ computations inside the container from experiment 0 to experiment 3

docker run  --name woodsim_container woodsim_image python3 /dune/dune-microstructure/experiment/compWood/runWoodSimulations.py 1 0 3


@CREATE THE FIGURES

# 1. Copy files/results (/compWood - folder) from the container to a $LOCALPATH on the Host machine: 
docker cp woodsim_container:/dune/dune-microstructure/experiment/compWood $LOCALPATH

# 2. Run python-script 'createFigures.py' to generate the paper figures. 
($LOCALPATH)  python3 createFigures.py 


