# build with "chmod +x runSimulations.sh"
# run via "./runSimulations.sh"

# Define your local path for simulation results and figures
echo "Define output path on your host machine: " 
# LOCALPATH='/home/klaus/Desktop/test'
read LOCALPATH

docker build --no-cache=true -t woodsim_image -f Containerfile .

docker rm woodsim_container

image_id=$(docker images --quiet | head -1)

echo "image ID used: $image_id"

docker run  --name woodsim_container $image_id python3 /dune/dune-microstructure/experiment/compWood/runWoodSimulations.py 1 0 3

docker cp woodsim_container:/dune/dune-microstructure/experiment/compWood $LOCALPATH

cd $LOCALPATH 

python3 $LOCALPATH/compWood/createFigures.py 

